'+--------------------------------------------------------------------------+
'|                                zSkin05                                   |
'|                                                                          |
'|                Example of what is going on behind the hood.              |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                                                                          |
'|                         Author Patrice TERRIER                           |
'|                            copyright(c) 2007                             |
'|                           www.zapsolution.com                            |
'|                         support@zapsolution.com                          |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                  Project started on : 08-04-2007 (MM-DD-YYYY)            |
'|                        Last revised : 08-10-2007 (MM-DD-YYYY)            |
'+--------------------------------------------------------------------------+
#COMPILE EXE "zSkin05.exe"

'DECLARE SUB skDebug LIB "SKENGINE.DLL" (BYVAL Msg$)

'-----------------------------------------------------------------
' Equates:  86
'-----------------------------------------------------------------
%WINAPI                                         = 1
%TRUE                                           = 1
%FALSE                                          = 0
%NULL                                           = 0
%WM_USER                                        = &H400
%ERROR_ALREADY_EXISTS                           = 183
%LOCALE_USER_DEFAULT                            = &H0400&
%LOCALE_SENGLANGUAGE                            = &H00001001   ' English name of language
%MAX_PATH                                       = 260  ' max. length of full pathname
%SRCCOPY                                        = &H00CC0020 ' (DWORD) dest = source
%BI_RGB                                         = 0&
%RGN_OR                                         = 2
%RDH_RECTANGLES                                 = 1
%ANSI_VAR_FONT                                  = 12
%DIB_RGB_COLORS                                 = 0 ' color table in RGBs
%CCHDEVICENAME                                  = 32
%CCHFORMNAME                                    = 32
%GRADIENT_FILL_RECT_H                           = &H00000000
%GRADIENT_FILL_RECT_V                           = &H00000001
%PRF_CHECKVISIBLE                               = &H00000001&
%PRF_NONCLIENT                                  = &H00000002&
%PRF_CLIENT                                     = &H00000004&
%PRF_CHILDREN                                   = &H00000010&
%BDR_RAISEDOUTER                                = &H0001
%BDR_RAISEDINNER                                = &H0004
%EDGE_RAISED                                    = %BDR_RAISEDOUTER OR %BDR_RAISEDINNER
%BF_LEFT                                        = &H0001
%BF_TOP                                         = &H0002
%BF_RIGHT                                       = &H0004
%BF_BOTTOM                                      = &H0008
%BF_RECT                                        = %BF_LEFT OR %BF_TOP OR %BF_RIGHT OR %BF_BOTTOM
%SW_HIDE                                        = 0
%SW_MAXIMIZE                                    = 3
%SW_SHOW                                        = 5
%SW_MINIMIZE                                    = 6
%SW_RESTORE                                     = 9
%WM_DESTROY                                     = &H2
%WM_SIZE                                        = &H5
%WM_SIZING                                      = &H214
%WM_PAINT                                       = &HF
%WM_CLOSE                                       = &H10
%WM_ERASEBKGND                                  = &H14
%WM_GETMINMAXINFO                               = &H24
%WM_SETFONT                                     = &H30
%WM_NCHITTEST                                   = &H084
%WM_NCACTIVATE                                  = &H86
%WM_COMMAND                                     = &H111
%WM_MOVING                                      = &H216
%WM_PRINT                                       = &H317
%WM_PRINTCLIENT                                 = &H318
%WM_SETTEXT                                     = &HC
%WM_NCLBUTTONDBLCLK                             = &H0A3
%HTNOWHERE                                      = 0
%HTCLIENT                                       = 1
%HTCAPTION                                      = 2
%HTLEFT                                         = 10
%HTRIGHT                                        = 11
%HTTOP                                          = 12
%HTTOPLEFT                                      = 13
%HTTOPRIGHT                                     = 14
%HTBOTTOM                                       = 15
%HTBOTTOMLEFT                                   = 16
%HTBOTTOMRIGHT                                  = 17
%WS_POPUP                                       = &H80000000
%WS_CHILD                                       = &H40000000
%WS_VISIBLE                                     = &H10000000
%WS_CLIPSIBLINGS                                = &H04000000
%WS_CLIPCHILDREN                                = &H02000000
%WS_TABSTOP                                     = &H00010000
%WS_DISABLED                                    = &H08000000
%WS_EX_TRANSPARENT                              = &H00000020
%CS_DROPSHADOW                                  = &H00020000
%CS_VREDRAW                                     = &H1
%CS_HREDRAW                                     = &H2
%CS_DBLCLKS                                     = &H8
%PM_REMOVE                                      = &H0001
%CW_USEDEFAULT                                  = &H80000000&
%SM_CXSCREEN                                    = 0
%SM_CYSCREEN                                    = 1
%COLOR_INFOTEXT                                 = 23
%COLOR_INFOBK                                   = 24
%IDC_ARROW                                      = 32512&
%SS_CENTER                                      = &H00000001
%TTS_ALWAYSTIP                                  = &H0001
%TTF_IDISHWND                                   = &H00000001
%TTF_SUBCLASS                                   = &H00000010
%TTM_ADDTOOL                                    = %WM_USER +  4
%TTM_UPDATETIPTEXT                              = %WM_USER + 12
%TTM_SETTIPBKCOLOR                              = %WM_USER + 19
%TTM_SETTIPTEXTCOLOR                            = %WM_USER + 20
%TTM_SETMAXTIPWIDTH                             = %WM_USER + 24

'-----------------------------------------------------------------
' TYPE and UNION structures:  15
'-----------------------------------------------------------------
TYPE RECTF
    nLEFT   AS SINGLE
    nTop    AS SINGLE
    nRIGHT  AS SINGLE
    nBottom AS SINGLE
END TYPE

TYPE RECT
    nLeft AS LONG
    nTop AS LONG
    nRight AS LONG
    nBottom AS LONG
END TYPE

TYPE POINTAPI
    x AS LONG
    y AS LONG
END TYPE

TYPE tagMSG
    hwnd AS DWORD
    message AS DWORD
    wParam AS LONG
    lParam AS LONG
    time AS DWORD
    pt AS POINTAPI
END TYPE

TYPE SECURITY_ATTRIBUTES
    nLength AS DWORD
    lpSecurityDescriptor AS LONG
    bInheritHandle AS LONG
END TYPE

TYPE FILETIME
    dwLowDateTime AS DWORD
    dwHighDateTime AS DWORD
END TYPE

TYPE WNDCLASSEX
    cbSize AS DWORD
    STYLE AS DWORD
    lpfnWndProc AS LONG
    cbClsExtra AS LONG
    cbWndExtra AS LONG
    hInstance AS DWORD
    hIcon AS DWORD
    hCursor AS DWORD
    hbrBackground AS DWORD
    lpszMenuName AS ASCIIZ PTR
    lpszClassName AS ASCIIZ PTR
    hIconSm AS DWORD
END TYPE

TYPE WIN32_FIND_DATA
  dwFileAttributes AS DWORD
  ftCreationTime AS FILETIME
  ftLastAccessTime AS FILETIME
  ftLastWriteTime AS FILETIME
  nFileSizeHigh AS DWORD
  nFileSizeLow AS DWORD
  dwReserved0 AS DWORD
  dwReserved1 AS DWORD
  cFileName AS ASCIIZ * %MAX_PATH
  cAlternateFileName AS ASCIIZ * 14
END TYPE

TYPE RGBQUAD
    rgbBlue AS BYTE
    rgbGreen AS BYTE
    rgbRed AS BYTE
    rgbReserved AS BYTE
END TYPE

TYPE BITMAPINFOHEADER
    biSize AS DWORD
    biWidth AS LONG
    biHeight AS LONG
    biPlanes AS WORD
    biBitCount AS WORD
    biCompression AS DWORD
    biSizeImage AS DWORD
    biXPelsPerMeter AS LONG
    biYPelsPerMeter AS LONG
    biClrUsed AS DWORD
    biClrImportant AS DWORD
END TYPE

TYPE RGNDATAHEADER
    dwSize AS DWORD
    iType AS DWORD
    nCount AS DWORD
    nRgnSize AS DWORD
    rcBound AS RECT
END TYPE

TYPE MYBITMAPINFO
    bmiHeader AS BITMAPINFOHEADER
    bmiColors(256) AS RGBQUAD ' Patrice
END TYPE

TYPE BITMAP
  bmType AS LONG
  bmWidth AS LONG
  bmHeight AS LONG
  bmWidthBytes AS LONG
  bmPlanes AS WORD
  bmBitsPixel AS WORD
  bmBits AS BYTE PTR
END TYPE

TYPE TRIVERTEX
  x AS LONG
  y AS LONG
  Red AS WORD
  Green AS WORD
  Blue AS WORD
  Alpha AS WORD
END TYPE

TYPE GRADIENT_RECT
  UpperLeft AS DWORD
  LowerRight AS DWORD
END TYPE

TYPE MINMAXINFO
    ptReserved AS POINTAPI
    ptMaxSize AS POINTAPI
    ptMaxPosition AS POINTAPI
    ptMinTrackSize AS POINTAPI
    ptMaxTrackSize AS POINTAPI
END TYPE

TYPE PAINTSTRUCT
  hDC AS DWORD
  fErase AS LONG
  rcPaint AS RECT
  fRestore AS LONG
  fIncUpdate AS LONG
  rgbReserved(0 TO 31) AS BYTE
END TYPE

TYPE DEVMODE
  dmDeviceName AS ASCIIZ * %CCHDEVICENAME
  dmSpecVersion AS WORD
  dmDriverVersion AS WORD
  dmSize AS WORD
  dmDriverExtra AS WORD
  dmFields AS DWORD
  dmOrientation AS INTEGER
  dmPaperSize AS INTEGER
  dmPaperLength AS INTEGER
  dmPaperWidth AS INTEGER
  dmScale AS INTEGER
  dmCopies AS INTEGER
  dmDefaultSource AS INTEGER
  dmPrintQuality AS INTEGER
  dmColor AS INTEGER
  dmDuplex AS INTEGER
  dmYResolution AS INTEGER
  dmTTOption AS INTEGER
  dmCollate AS INTEGER
  dmFormName AS ASCIIZ * %CCHFORMNAME
  dmLogPixels AS WORD
  dmBitsPerPel AS DWORD
  dmPelsWidth AS DWORD
  dmPelsHeight AS DWORD
  dmDisplayFlags AS DWORD
  dmDisplayFrequency AS DWORD
  dmICMMethod AS DWORD
  dmICMIntent AS DWORD
  dmMediaType AS DWORD
  dmDitherType AS DWORD
  dmICCManufacturer AS DWORD
  dmICCModel AS DWORD
  dmPanningWidth AS DWORD
  dmPanningHeight AS DWORD
END TYPE

TYPE TOOLINFO
  cbSize AS DWORD
  uFlags AS DWORD
  hwnd AS DWORD
  uId AS DWORD
  rec AS RECT
  hinst AS DWORD
  lpszText AS ASCIIZ PTR
  lParam AS LONG
  lpReserved AS DWORD
END TYPE

'-----------------------------------------------------------------
' Declared Functions:  70
'-----------------------------------------------------------------
DECLARE FUNCTION GetDlgCtrlID LIB "USER32.DLL" ALIAS "GetDlgCtrlID" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION LoadIcon LIB "USER32.DLL" ALIAS "LoadIconA" (BYVAL hInstance AS DWORD, lpIconName AS ASCIIZ) AS DWORD
DECLARE FUNCTION MyCreateDIBSection LIB "GDI32.DLL" ALIAS "CreateDIBSection" (BYVAL hdc AS DWORD, pbmi AS MYBITMAPINFO, BYVAL dwUsage AS DWORD, BYVAL ppvBits AS DWORD, BYVAL hSection AS DWORD, BYVAL dwOffset AS DWORD) AS DWORD
DECLARE FUNCTION AdjustWindowRectEx LIB "USER32.DLL" ALIAS "AdjustWindowRectEx" (lpRect AS RECT, BYVAL dsStyle AS LONG, BYVAL bMenu AS LONG, BYVAL dwEsStyle AS DWORD) AS LONG
DECLARE FUNCTION BeginPaint LIB "USER32.DLL" ALIAS "BeginPaint" (BYVAL hWnd AS DWORD, lpPaint AS PAINTSTRUCT) AS LONG
DECLARE FUNCTION BitBlt LIB "GDI32.DLL" ALIAS "BitBlt" (BYVAL hDestDC AS DWORD, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL nWidth AS LONG, BYVAL nHeight AS LONG, BYVAL hSrcDC AS DWORD, BYVAL xSrc AS LONG, BYVAL ySrc AS LONG, _
                 BYVAL dwRop AS DWORD) AS LONG
DECLARE FUNCTION CallWindowProc LIB "USER32.DLL" ALIAS "CallWindowProcA" (BYVAL lpPrevWndFunc AS DWORD, BYVAL hWnd AS DWORD, BYVAL uMsg AS DWORD, BYVAL wParam AS DWORD, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION CloseHandle LIB "KERNEL32.DLL" ALIAS "CloseHandle" (BYVAL hObject AS DWORD) AS LONG
DECLARE FUNCTION CreateCompatibleDC LIB "GDI32.DLL" ALIAS "CreateCompatibleDC" (BYVAL hdc AS DWORD) AS DWORD
DECLARE FUNCTION CreateCompatibleBitmap LIB "GDI32.DLL" ALIAS "CreateCompatibleBitmap" (BYVAL hdc AS DWORD, BYVAL nWidth AS LONG, BYVAL nHeight AS LONG) AS DWORD
DECLARE FUNCTION CreateIC LIB "GDI32.DLL" ALIAS "CreateICA" (lpDriverName AS ASCIIZ, lpDeviceName AS ASCIIZ, lpOutput AS ASCIIZ, lpInitData AS DEVMODE) AS DWORD
DECLARE FUNCTION CreateMutex LIB "KERNEL32.DLL" ALIAS "CreateMutexA" (lpMutexAttributes AS SECURITY_ATTRIBUTES, BYVAL bInitialOwner AS LONG, lpName AS ASCIIZ) AS LONG
DECLARE FUNCTION CreateSolidBrush LIB "GDI32.DLL" ALIAS "CreateSolidBrush" (BYVAL crColor AS DWORD) AS DWORD
DECLARE FUNCTION CreateWindowEx LIB "USER32.DLL" ALIAS "CreateWindowExA" (BYVAL dwExStyle AS DWORD, lpClassName AS ASCIIZ, lpWindowName AS ASCIIZ, BYVAL dwStyle AS DWORD, BYVAL x AS LONG, BYVAL y AS LONG, _
    BYVAL nWidth AS LONG, BYVAL nHeight AS LONG, BYVAL hWndParent AS DWORD, BYVAL hMenu AS DWORD, BYVAL hInstance AS DWORD, lpParam AS ANY) AS DWORD
DECLARE FUNCTION DefWindowProc LIB "USER32.DLL" ALIAS "DefWindowProcA" (BYVAL hWnd AS DWORD, BYVAL uMsg AS DWORD, BYVAL wParam AS DWORD, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION DeleteDC LIB "GDI32.DLL" ALIAS "DeleteDC" (BYVAL hdc AS DWORD) AS LONG
DECLARE FUNCTION DeleteObject LIB "GDI32.DLL" ALIAS "DeleteObject" (BYVAL hObject AS DWORD) AS LONG
DECLARE FUNCTION DispatchMessage LIB "USER32.DLL" ALIAS "DispatchMessageA" (lpMsg AS tagMSG) AS LONG
DECLARE FUNCTION DrawEdge LIB "USER32.DLL" ALIAS "DrawEdge" (BYVAL hDC AS DWORD, qrc AS RECT, BYVAL edge AS LONG, BYVAL grfFlags AS LONG) AS LONG
DECLARE FUNCTION EndPaint LIB "USER32.DLL" ALIAS "EndPaint" (BYVAL hWnd AS DWORD, lpPaint AS PAINTSTRUCT) AS LONG
DECLARE FUNCTION EnumChildWindows LIB "USER32.DLL" ALIAS "EnumChildWindows" (BYVAL hwndParent AS DWORD, BYVAL lpEnumFunc AS LONG, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION FillRect LIB "USER32.DLL" ALIAS "FillRect" (BYVAL hDC AS DWORD, lpRect AS RECT, BYVAL hBrush AS DWORD) AS LONG
DECLARE FUNCTION EnableWindow LIB "USER32.DLL" ALIAS "EnableWindow" (BYVAL hWnd AS DWORD, BYVAL fEnable AS LONG) AS LONG
DECLARE FUNCTION FindClose LIB "KERNEL32.DLL" ALIAS "FindClose" (BYVAL hFindFile AS DWORD) AS LONG
DECLARE FUNCTION FindFirstFile LIB "KERNEL32.DLL" ALIAS "FindFirstFileA" (lpFileName AS ASCIIZ, lpFindFileData AS WIN32_FIND_DATA) AS DWORD
DECLARE FUNCTION FindWindow LIB "USER32.DLL" ALIAS "FindWindowA" (lpClassName AS ASCIIZ, lpWindowName AS ASCIIZ) AS LONG
DECLARE FUNCTION CombineRgn LIB "GDI32.DLL" ALIAS "CombineRgn" (BYVAL hDestRgn AS DWORD, BYVAL hSrcRgn1 AS DWORD, BYVAL hSrcRgn2 AS DWORD, BYVAL nCombineMode AS LONG) AS LONG
DECLARE FUNCTION GetWindowText LIB "USER32.DLL" ALIAS "GetWindowTextA" (BYVAL hWnd AS DWORD, lpString AS ASCIIZ, BYVAL cch AS LONG) AS LONG
DECLARE FUNCTION ExtCreateRegion LIB "GDI32.DLL" ALIAS "ExtCreateRegion" (lpXform AS ANY, BYVAL nCount AS DWORD, lpRgnData AS ANY) AS DWORD
DECLARE FUNCTION FreeLibrary LIB "KERNEL32.DLL" ALIAS "FreeLibrary" (BYVAL hLibModule AS DWORD) AS LONG
DECLARE FUNCTION SetFocus LIB "USER32.DLL" ALIAS "SetFocus" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION GetAsyncKeyState LIB "USER32.DLL" ALIAS "GetAsyncKeyState" (BYVAL vKey AS LONG) AS INTEGER
DECLARE FUNCTION GetClassInfoEx LIB "USER32.DLL" ALIAS "GetClassInfoExA" (BYVAL hInst AS DWORD, lpszClass AS ASCIIZ, lpWndClass AS WNDCLASSEX) AS LONG
DECLARE FUNCTION GetClientRect LIB "USER32.DLL" ALIAS "GetClientRect" (BYVAL hwnd AS DWORD, lpRect AS RECT) AS LONG
DECLARE FUNCTION GetCursor LIB "USER32.DLL" ALIAS "GetCursor" () AS LONG
DECLARE FUNCTION GetCursorPos LIB "USER32.DLL" ALIAS "GetCursorPos" (lpPoint AS POINTAPI) AS LONG
DECLARE FUNCTION GetDlgItem LIB "USER32.DLL" ALIAS "GetDlgItem" (BYVAL hDlg AS DWORD, BYVAL nIDDlgItem AS LONG) AS DWORD
DECLARE FUNCTION GetForegroundWindow LIB "USER32.DLL" ALIAS "GetForegroundWindow" () AS DWORD
DECLARE FUNCTION GetFocus LIB "USER32.DLL" ALIAS "GetFocus" () AS DWORD
DECLARE FUNCTION GetLastError LIB "KERNEL32.DLL" ALIAS "GetLastError" () AS LONG
DECLARE FUNCTION GetLocaleInfo LIB "KERNEL32.DLL" ALIAS "GetLocaleInfoA" (BYVAL Locale AS LONG, BYVAL LCType AS LONG, lpLCData AS ASCIIZ, BYVAL cchData AS LONG) AS LONG
DECLARE FUNCTION GetMessage LIB "USER32.DLL" ALIAS "GetMessageA" (lpMsg AS tagMSG, BYVAL hWnd AS DWORD, BYVAL uMsgFilterMin AS DWORD, BYVAL uMsgFilterMax AS DWORD) AS LONG
DECLARE FUNCTION GetModuleHandle LIB "KERNEL32.DLL" ALIAS "GetModuleHandleA" (lpModuleName AS ASCIIZ) AS DWORD
DECLARE FUNCTION GetObject LIB "GDI32.DLL" ALIAS "GetObjectA" (BYVAL hObject AS DWORD, BYVAL nCount AS LONG, lpObject AS ANY) AS LONG
DECLARE FUNCTION SetWindowRgn LIB "USER32.DLL" ALIAS "SetWindowRgn" (BYVAL hWnd AS DWORD, BYVAL hRgn AS DWORD, BYVAL bRedraw AS LONG) AS LONG
DECLARE FUNCTION GetParent LIB "USER32.DLL" ALIAS "GetParent" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION GetProcAddress LIB "KERNEL32.DLL" ALIAS "GetProcAddress" (BYVAL hModule AS DWORD, lpProcName AS ASCIIZ) AS LONG
DECLARE FUNCTION GetStockObject LIB "GDI32.DLL" ALIAS "GetStockObject" (BYVAL nIndex AS LONG) AS DWORD
DECLARE FUNCTION GetSysColor LIB "USER32.DLL" ALIAS "GetSysColor" (BYVAL nIndex AS LONG) AS LONG
DECLARE FUNCTION GetSystemMetrics LIB "USER32.DLL" ALIAS "GetSystemMetrics" (BYVAL nIndex AS LONG) AS LONG
DECLARE FUNCTION GetWindowLong LIB "USER32.DLL" ALIAS "GetWindowLongA" (BYVAL hWnd AS DWORD, BYVAL nIndex AS LONG) AS LONG
DECLARE FUNCTION GetWindowRect LIB "USER32.DLL" ALIAS "GetWindowRect" (BYVAL hWnd AS DWORD, lpRect AS RECT) AS LONG
DECLARE FUNCTION GradientFill LIB "MSIMG32.DLL" ALIAS "GradientFill" (BYVAL hdc AS DWORD, pVertex AS TRIVERTEX, BYVAL dwNumVertex AS DWORD, pMesh AS ANY, BYVAL dwNumMesh AS DWORD, BYVAL dwMode AS DWORD) AS LONG
DECLARE FUNCTION InvalidateRect LIB "USER32.DLL" ALIAS "InvalidateRect" (BYVAL hWnd AS DWORD, lpRect AS RECT, BYVAL bErase AS LONG) AS LONG
DECLARE FUNCTION IsIconic LIB "USER32.DLL" ALIAS "IsIconic" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION IsWindow LIB "USER32.DLL" ALIAS "IsWindow" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION IsWindowEnabled LIB "USER32.DLL" ALIAS "IsWindowEnabled" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION IsWindowVisible LIB "USER32.DLL" ALIAS "IsWindowVisible" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION IsZoomed LIB "USER32.DLL" ALIAS "IsZoomed" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION LoadCursor LIB "USER32.DLL" ALIAS "LoadCursorA" (BYVAL hInstance AS DWORD, lpCursorName AS ASCIIZ) AS DWORD
DECLARE FUNCTION LoadLibrary LIB "KERNEL32.DLL" ALIAS "LoadLibraryA" (lpLibFileName AS ASCIIZ) AS LONG
DECLARE FUNCTION MoveWindow LIB "USER32.DLL" ALIAS "MoveWindow" (BYVAL hWnd AS DWORD, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL nWidth AS LONG, BYVAL nHeight AS LONG, BYVAL bRepaint AS LONG) AS LONG
DECLARE FUNCTION PeekMessage LIB "USER32.DLL" ALIAS "PeekMessageA" (lpMsg AS tagMSG, BYVAL hWnd AS DWORD, BYVAL dwMsgFilterMin AS DWORD, BYVAL dwMsgFilterMax AS DWORD, BYVAL dwRemoveMsg AS DWORD) AS LONG
DECLARE FUNCTION PtInRect LIB "USER32.DLL" ALIAS "PtInRect" (lpRect AS RECT, BYVAL ptx AS LONG, BYVAL pty AS LONG) AS LONG
DECLARE FUNCTION RegisterClassEx LIB "USER32.DLL" ALIAS "RegisterClassExA" (pcWndClassEx AS WNDCLASSEX) AS WORD
DECLARE FUNCTION ScreenToClient LIB "USER32.DLL" ALIAS "ScreenToClient" (BYVAL hWnd AS DWORD, lpPoint AS POINTAPI) AS LONG
DECLARE FUNCTION SelectObject LIB "GDI32.DLL" ALIAS "SelectObject" (BYVAL hdc AS DWORD, BYVAL hObject AS DWORD) AS DWORD
DECLARE FUNCTION SendMessage LIB "USER32.DLL" ALIAS "SendMessageA" (BYVAL hWnd AS DWORD, BYVAL dwMsg AS DWORD, BYVAL wParam AS DWORD, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION SetForegroundWindow LIB "USER32.DLL" ALIAS "SetForegroundWindow" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION SetRect LIB "USER32.DLL" ALIAS "SetRect" (lpRect AS RECT, BYVAL X1 AS LONG, BYVAL Y1 AS LONG, BYVAL X2 AS LONG, BYVAL Y2 AS LONG) AS LONG
DECLARE FUNCTION SetWindowLong LIB "USER32.DLL" ALIAS "SetWindowLongA" (BYVAL hWnd AS DWORD, BYVAL nIndex AS LONG, BYVAL lNewLong AS LONG) AS LONG
DECLARE FUNCTION ShowWindow LIB "USER32.DLL" ALIAS "ShowWindow" (BYVAL hWnd AS DWORD, BYVAL nCmdShow AS LONG) AS LONG
DECLARE FUNCTION TranslateMessage LIB "USER32.DLL" ALIAS "TranslateMessage" (lpMsg AS tagMSG) AS LONG
DECLARE FUNCTION UpdateWindow LIB "USER32.DLL" ALIAS "UpdateWindow" (BYVAL hWnd AS DWORD) AS LONG

'-----------------------------------------------------------------
' Declared Subs:  2
'-----------------------------------------------------------------
DECLARE SUB InitCommonControls LIB "COMCTL32.DLL" ALIAS "InitCommonControls" ()
DECLARE SUB PostQuitMessage LIB "USER32.DLL" ALIAS "PostQuitMessage" (BYVAL nExitCode AS LONG)

'------------------------------------------------------------------------------------------
#RESOURCE "control.pbr"

'------------------------------------------------------------------------------------------
' GDIPLUS section
'------------------------------------------------------------------------------------------
$Dot        = "."
$zLim       = "|"
$GDIPLUSIMG = ".DIB.EMF.GIF.JPG.JPEG.PNG.TIF.TIFF.WMF."
$GDIPLUSEXT = $GDIPLUSIMG + "BMP.ICO."
%UnitPixel  = 2 ' Each unit is one device pixel.

%MatrixOrderPrepend = 0
%MatrixOrderAppend = 1

%FontStyleRegular = 0
%TextRenderingHintAntiAlias = 4

%ZD_TextHorzUp = &H0                  ' Horizontal text orientation
%ZD_TextVertUp = &H1                  ' Vertical text orientation from bottom to top
%ZD_TextVertDn = &H2                  ' Vertical text orientation from top to bottom

TYPE GdiplusStartupInput
   GdiplusVersion AS LONG             ' Must be 1
   DebugEventCallback AS LONG         ' Ignored on free builds
   SuppressBackgroundThread AS LONG   ' FALSE unless you're prepared to call
                                      ' the hook/unhook functions properly
   SuppressExternalCodecs AS LONG     ' FALSE unless you want GDI+ only to use
                                      ' its internal image codecs.
END TYPE

DECLARE FUNCTION GdiplusStartup LIB "gdiplus.dll" ALIAS "GdiplusStartup" (token&, inputbuf AS GdiplusStartupInput, OPTIONAL BYVAL outputbuf&) AS LONG
DECLARE FUNCTION GdiplusShutdown LIB "gdiplus.dll" ALIAS "GdiplusShutdown" (BYVAL token&) AS LONG
DECLARE FUNCTION GdipLoadImageFromFile LIB "gdiplus.dll" ALIAS "GdipLoadImageFromFile" (zFilName AS ASCIIZ, nImage&) AS LONG
DECLARE FUNCTION GdipGetImageWidth LIB "gdiplus.dll" ALIAS "GdipGetImageWidth" (BYVAL nImage&, nWidth&) AS LONG
DECLARE FUNCTION GdipGetImageHeight LIB "gdiplus.dll" ALIAS "GdipGetImageHeight" (BYVAL nImage&, Height&) AS LONG
DECLARE FUNCTION GdipDisposeImage LIB "gdiplus.dll" ALIAS "GdipDisposeImage" (BYVAL nImage&) AS LONG
DECLARE FUNCTION GdipCreateFromHDC LIB "gdiplus.dll" ALIAS "GdipCreateFromHDC" (BYVAL hdc&, graphics&) AS LONG
DECLARE FUNCTION GdipDrawImageRectRectI LIB "gdiplus.dll" ALIAS "GdipDrawImageRectRectI" (BYVAL graphics&, BYVAL nImage&, BYVAL dstx&, BYVAL dsty&, BYVAL dstwidth&, BYVAL dstheight&, BYVAL srcx&, BYVAL srcy&, BYVAL srcwidth&, BYVAL srcheight&, _
                                                                                          BYVAL srcUnit&, OPTIONAL BYVAL imageAttributes&, OPTIONAL BYVAL pCALLBACK&, OPTIONAL BYVAL callbackData&) AS LONG
DECLARE FUNCTION GdipCreateStringFormat LIB "gdiplus.dll" ALIAS "GdipCreateStringFormat" (BYVAL formatAttributes&, BYVAL language AS INTEGER, StringFormat&) AS LONG
DECLARE FUNCTION GdipDeleteGraphics LIB "gdiplus.dll" ALIAS "GdipDeleteGraphics" (BYVAL graphics&) AS LONG
DECLARE FUNCTION GdipCreateFont LIB "gdiplus.dll" ALIAS "GdipCreateFont" (BYVAL fontFamily&, BYVAL emSize!, BYVAL style&, BYVAL unit&, createdfont&) AS LONG
DECLARE FUNCTION GdipCreateFontFromDC LIB "gdiplus.dll" ALIAS "GdipCreateFontFromDC" (BYVAL hDC&, createdfont&) AS LONG
DECLARE FUNCTION GdipCreateFontFamilyFromName LIB "gdiplus.dll" ALIAS "GdipCreateFontFamilyFromName" (zFontName AS ASCIIZ, BYVAL fontCollection&, fontFamily&) AS LONG
DECLARE FUNCTION GdipDeleteFont LIB "gdiplus.dll" ALIAS "GdipDeleteFont" (BYVAL curFont&) AS LONG
DECLARE FUNCTION GdipMeasureString LIB "gdiplus.dll" ALIAS "GdipMeasureString" (BYVAL graphics&, zString AS ASCIIZ, BYVAL length&, BYVAL thefont&, layoutRect AS RECTF, BYVAL StringFormat&, boundingBox AS RECTF, _
                                                                                codepointsFitted&, linesFilled&) AS LONG
DECLARE FUNCTION GdipDeleteFontFamily LIB "gdiplus.dll" ALIAS "GdipDeleteFontFamily" (BYVAL fontFamily&) AS LONG
DECLARE FUNCTION GdipDeleteBrush LIB "gdiplus.dll" ALIAS "GdipDeleteBrush" (BYVAL brush&) AS LONG
DECLARE FUNCTION GdipResetWorldTransform LIB "gdiplus.dll" ALIAS "GdipResetWorldTransform" (BYVAL graphics&) AS LONG
DECLARE FUNCTION GdipDeleteStringFormat LIB "gdiplus.dll" ALIAS "GdipDeleteStringFormat" (BYVAL StringFormat&) AS LONG
DECLARE FUNCTION GdipDrawString LIB "gdiplus.dll" ALIAS "GdipDrawString" (BYVAL graphics&, zStr AS ASCIIZ, BYVAL length&, BYVAL thefont&, layoutRect AS RECTF, BYVAL StringFormat&, BYVAL brush&) AS LONG
DECLARE FUNCTION GdipCreateSolidFill LIB "gdiplus.dll" ALIAS "GdipCreateSolidFill" (BYVAL argb&, brush&) AS LONG
DECLARE FUNCTION GdipSetTextRenderingHint LIB "gdiplus.dll" ALIAS "GdipSetTextRenderingHint" (BYVAL graphics&, BYVAL mode&) AS LONG
DECLARE FUNCTION GdipRotateWorldTransform LIB "gdiplus.dll" ALIAS "GdipRotateWorldTransform" (BYVAL graphics&, BYVAL angle!, BYVAL order&) AS LONG
DECLARE FUNCTION GdipSetStringFormatFlags LIB "gdiplus.dll" ALIAS "GdipSetStringFormatFlags" (BYVAL StringFormat&, BYVAL flags&) AS LONG
DECLARE FUNCTION GdipTranslateWorldTransform LIB "gdiplus.dll" ALIAS "GdipTranslateWorldTransform" (BYVAL graphics&, BYVAL dx!, BYVAL dy!, BYVAL order&) AS LONG
DECLARE FUNCTION GdipCreateBitmapFromHICON LIB "gdiplus.dll" ALIAS "GdipCreateBitmapFromHICON" (BYVAL hicon&, nBitmap&) AS LONG
DECLARE FUNCTION GdipCreateBitmapFromHBITMAP LIB "gdiplus.dll" ALIAS "GdipCreateBitmapFromHBITMAP" (BYVAL hbm&, BYVAL hpal&, nBitmap&) AS LONG
DECLARE FUNCTION GdipCreateBitmapFromGraphics LIB "gdiplus.dll" ALIAS "GdipCreateBitmapFromGraphics" (BYVAL nWidth&, BYVAL Height&, BYVAL graphics&, nBitmap&) AS LONG

'// Load the GDI+ Dll
FUNCTION zGdipStart() EXPORT AS LONG
    DIM GpInput AS GdiplusStartupInput
    GpInput.GdiplusVersion = 1
    IF GdiplusStartup(hGDIplus&, GpInput) = 0 THEN FUNCTION = hGDIplus&
END FUNCTION

'// GDIPLUS unload (unload the GDIPLUS.DLL)
SUB zGdipEnd(BYVAL hGDIplus&) EXPORT
  ' Unload the GDI+ Dll
    IF hGDIplus& THEN CALL GdiplusShutdown(hGDIplus&): hGDIplus& = 0
END SUB

'------------------------------------------------------------------------------------------
' ANCHOR section
'------------------------------------------------------------------------------------------
TYPE ANCHORPROPERTY
    hWnd        AS LONG
    anchor      AS LONG
    rc          AS RECT
    centerx     AS LONG
    centery     AS LONG
END TYPE

%ANCHOR_NONE                = 0
%ANCHOR_WIDTH               = 1
%ANCHOR_RIGHT               = 2
%ANCHOR_CENTER_HORZ         = 3
%ANCHOR_HEIGHT              = 4
%ANCHOR_HEIGHT_WIDTH        = 5
%ANCHOR_HEIGHT_RIGHT        = 6
%ANCHOR_BOTTOM              = 7
%ANCHOR_BOTTOM_WIDTH        = 8
%ANCHOR_BOTTOM_RIGHT        = 9
%ANCHOR_CENTER_HORZ_BOTTOM  = 10
%ANCHOR_CENTER_VERT         = 11
%ANCHOR_CENTER_VERT_RIGHT   = 12
%ANCHOR_CENTER              = 13

GLOBAl gProp() AS ANCHORPROPERTY, gColorCaption AS LONG

'------------------------------------------------------------------------------------------
' LOCAL section
'------------------------------------------------------------------------------------------

%XMIN_SIZE = 600
%YMIN_SIZE = 400

%ID_CLOSE    = -32768
%ID_RESTORE  = -32767
%ID_MAXIMIZE = -32766
%ID_MINIMIZE = -32765
%ID_LED      = -32764
%ID_DOCKIN   = -32763
%ID_DOCKOUT  = -32762

%IMAGE_EXTRA  = 1

' DO NOT use or alter these properties!
%FORM_TopLeft     = 1  ' Skin top left corner
%FORM_TopSide     = 2  ' Skin stretched top side
%FORM_TopRight    = 3  ' Skin top right corner
%FORM_SideLeft    = 4  ' Skin stretched left side
%FORM_Center      = 5  ' Skin center
%FORM_SideRight   = 6  ' Skin stretched right side
%FORM_BottomLeft  = 7  ' Skin bottom left corner
%FORM_BottomSide  = 8  ' Skin stretched bottom side
%FORM_BottomRight = 9  ' Skin bottom right corner
%FORM_PaintDC     = 10 ' Internal DC
%FORM_PaintBitmap = 11 ' Memory Bitmap

%EXTEND_EXTRA = %FORM_PaintBitmap ' MAXIMUM 40 bytes on 95/98/ME

'////////////////////////////////////////////////////////////////////////////////////////
'// These are our SKIN properties
'// ultimately these parameters will be stored in a SKS file
$CAPTION_FONT           = "Trebuchet MS" ' Caption font
%CAPTION_FONT_HEIGHT    = 20             ' Caption font size
%CAPTION_X              = 34             ' Caption X location
%CAPTION_Y              = 4              ' Caption Y location
%CAPTION_COLOR_INACTIVE = &H634C49       ' RGB(73,76,99)
%CAPTION_COLOR_ACTIVE   = &HC09986       ' RGB(134,153,190)
%BUTPUSH_FIXED_SIZE_X   = 7              ' Horizontal fixed border size for stretched pushbutton
%BUTPUSH_FIXED_SIZE_Y   = 5              ' Vertical fixed border size for stretched pushbutton
%BUTPUSH_FONT_SIZE      = 14             ' Push button font size
%ICON_X_LOCATION        = 10             ' Icon X location
%ICON_Y_LOCATION        = 6              ' Icon Y location
%ICON_SIZE              = 24             ' Icon size
'////////////////////////////////////////////////////////////////////////////////////////

%BS_PUSHBUTTON      = &H0&
%BS_BITMAP          = &H80&
%BS_GROUPBOX        = &H7&
%BUTTON_Style       = 1 
%BUTTON_Image       = 2
%BUTTON_TEXT_COLOR  = 3

%ID_PUSHBUTTON      = 1
%ID_SCRIPTBUTTON    = 2
%ID_PLAYBUTTON      = 3
%ID_LEFTBUTTON      = 4
%ID_RIGHTBUTTON     = 5
%ID_FRAMEBUTTON     = 6
%ID_CRYSTALBUTTON   = 7

' WinXP Theme support declares (if applicable)
DECLARE FUNCTION EnableDialogTheme(BYVAL hDlg AS DWORD, BYVAL dwStyle AS DWORD) AS LONG
DECLARE FUNCTION IsThemeActive() AS LONG

'// Get Red byte from a RGB color.
FUNCTION zGetRValue (BYVAL colrRGB???) AS BYTE
    FUNCTION = (colrRGB??? AND &H000000FF???)
END FUNCTION

'// Get Green byte from a RGB color.
FUNCTION zGetGValue (BYVAL colrRGB???) AS BYTE
    SHIFT RIGHT colrRGB???, 8
    FUNCTION = (colrRGB??? AND &H000000FF???)
END FUNCTION

'// Get Blue byte from a RGB color.
FUNCTION zGetBValue (BYVAL colrRGB???) AS BYTE
    SHIFT RIGHT colrRGB???, 16
    FUNCTION = (colrRGB??? AND &H000000FF???)
END FUNCTION

' Custom types
TYPE COLORBYTES
    B AS BYTE
    G AS BYTE
    R AS BYTE
    A AS BYTE
END TYPE

TYPE COLORLONG
   longval AS LONG
END TYPE

SUB zSplitColorARGB (BYVAL ARGB&, Alpha AS BYTE, Red AS BYTE, Green AS BYTE, Blue AS BYTE)
    DIM bytestruct AS COLORBYTES
    LSET bytestruct = MKL$(ARGB&)
    Alpha? = bytestruct.A
    Red?   = bytestruct.R
    Green? = bytestruct.G
    Blue?  = bytestruct.B
END SUB

FUNCTION zColorARGB (BYVAL Alpha AS BYTE, BYVAL ColrRGB???) AS LONG
    DIM bytestruct AS COLORBYTES
    DIM result AS COLORLONG

    bytestruct.A = Alpha
    bytestruct.R = zGetRValue(ColrRGB???)
    bytestruct.G = zGetGValue(ColrRGB???)
    bytestruct.B = zGetBValue(ColrRGB???)

    LSET result = bytestruct
    FUNCTION = result.longval
END FUNCTION

'// Render GDIPLUS string into graphics
FUNCTION zDrawStringFormatedEx(BYVAL graphics AS LONG, BYVAL sTxt AS STRING, _
                               BYVAL x AS LONG, BYVAL y AS LONG, BYVAL xWidth AS LONG, BYVAL yHeight AS LONG, _
                               BYVAL ColrARGB AS LONG, BYVAL TextRendering AS LONG, BYVAL curFont AS LONG, _
                               BYVAL ShadowOffSet AS LONG, BYVAL UseStrFormat AS LONG) AS LONG
    LOCAL rcLayout AS RECTF
    LOCAl nRet, brush, strFormat AS LONG
    nRet = -1
    IF graphics THEN
       IF UseStrFormat THEN
          SWAP xWidth, yHeight
          IF UseStrFormat = %ZD_TextVertUp THEN
             CALL GdipTranslateWorldTransform(graphics, 0, y + yHeight, %MatrixOrderPrepend)
             CALL GdipRotateWorldTransform(graphics, 270, %MatrixOrderPrepend)
          ELSE
             CALL GdipCreateStringFormat(0, 0, strFormat)
             CALL GdipSetStringFormatFlags(strFormat, UseStrFormat)
          END IF
       END IF

       CALL GdipSetTextRenderingHint(graphics, TextRendering)

       IF ShadowOffset THEN
        ' Create a brush for the text shadow with
          CALL GdipCreateSolidFill(zColorARGB(128, 0), brush)
        ' Set up a drawing area for the shadow
        ' NOTE: Leaving the right and bottom values at zero means there is no boundary
          rcLayout.nLeft = x + ShadowOffset
          rcLayout.nTop = y + ShadowOffset

          IF UseStrFormat = %ZD_TextVertUp THEN
             rcLayout.nLEFT = 0  - ABS(ShadowOffset)
             rcLayout.nTop = x + ShadowOffset
             rcLayout.nRIGHT = yHeight: rcLayout.nBottom = xWidth
          END IF

          nRet = GdipDrawString(graphics, (UCODE$(sTxt)), LEN(sTxt), curFont, rcLayout, strFormat, brush)
        ' Cleanup
          CALL GdipDeleteBrush(brush)
       END IF

       CALL GdipCreateSolidFill(ColrARGB, brush)
       rcLayout.nLeft  = x:      rcLayout.nTop    = y
       rcLayout.nRight = xWidth: rcLayout.nBottom = yHeight

       IF UseStrFormat = %ZD_TextVertUp THEN
          rcLayout.nLEFT = 0: rcLayout.nTop = x
          rcLayout.nRIGHT = yHeight: rcLayout.nBottom = xWidth
       END IF

       nRet = GdipDrawString(graphics, (UCODE$(sTxt)), LEN(sTxt), curFont, rcLayout, strFormat, brush)

     ' Cleanup
       IF UseStrFormat THEN
          IF UseStrFormat = %ZD_TextVertUp THEN
             CALL GdipResetWorldTransform(graphics)
          ELSE
             CALL GdipDeleteStringFormat(strFormat)
          END IF
       END IF
       CALL GdipDeleteBrush(brush)
    END IF
    FUNCTION = nRet
END FUNCTION

'// Draw text using GDIPLUS on any DC
FUNCTION zDrawTextToDC( _
         BYVAL hDC AS LONG, _
         zUseText AS ASCIIZ, _
         BYVAL x AS LONG, _
         BYVAL y AS LONG, _
         BYVAL ColrARGB AS LONG, _
         zUseFont AS ASCIIZ, _
         BYVAL UseSize AS LONG, _
         BYVAL Use3D AS LONG, _
         BYVAL UseStrFormat AS LONG) AS LONG
    LOCAL layoutRect  AS RECTF
    LOCAL boundingBox AS RECTF
    LOCAl nRet, graphics, strFormat, Fam, TempFont, zdW, zdH AS LONG
    LOCAL sUseText, sUseFont, sCaption AS STRING

    sUseText = zUseText: sUseFont = zUseFont

  ' Create matching font
    CALL GdipCreateFontFamilyFromName((UCODE$(sUseFont)), 0, Fam)
    IF Fam THEN
       CALL GdipCreateFont(Fam, UseSize, %FontStyleRegular, %UnitPixel, TempFont)
       IF TempFont THEN
        ' Shadow offset use NULL if you don't want a shadow,
        ' use positive value to display shadow right, negative value to display shadow left
        ' Draw the string
          CALL GdipCreateStringFormat(0, 0, strFormat)
          CALL GdipCreateFromHDC(hDC, graphics)
          sCaption = TRIM$(sUseText, ANY CHR$(0,32))
          CALL GdipMeasureString(graphics, (UCODE$(sCaption)), LEN(sCaption), TempFont, layoutRect, strFormat, boundingBox, BYVAL %NULL, BYVAL %NULL)
          CALL GdipDeleteStringFormat(strFormat)
          zdW   = CLNG(boundingBox.nRight + .5)
          zdH   = CLNG(boundingBox.nBottom + 1.5)
          nRet = zDrawStringFormatedEx(graphics, _
                                       sUseText, _
                                       x, y, _
                                       zdW, zdH, _
                                       ColrARGB, _
                                       %TextRenderingHintAntiAlias, _
                                       TempFont, _
                                       Use3D, _
                                       UseStrFormat)
          CALL GdipDeleteGraphics(graphics)
          CALL GdipDeleteFont(TempFont) ' Delete the font object
       END IF
       CALL GdipDeleteFontFamily(Fam)   ' Delete the font family object
    END IF
    FUNCTION = nRet
END FUNCTION

'// Get window texte.
FUNCTION zGetCTLText(BYVAL hCtrl AS LONG) AS STRING
    LOCAL szText AS ASCIIZ * 4096, Length AS LONG
    Length = GetWindowText(hCtrl, szText, SIZEOF(szText))
    IF Length THEN FUNCTION = LEFT$(szText, Length)
END FUNCTION

'// Static function to save the main window handle.
FUNCTION zMainWindow(BYVAL hMain AS LONG) AS LONG
    STATIC WasMain AS LONG
    IF hMain THEN
       WasMain = hMain
    END IF
    FUNCTION = WasMain
END FUNCTION

'// Retrieve the current module instance.
FUNCTION zInstance () AS LONG
    FUNCTION = GetModuleHandle("")
END FUNCTION

'// To detect the language being used on the host computer.
FUNCTION IsFrench() AS LONG
    L$ = SPACE$(6)
    CALL GetLocaleInfo(%LOCALE_USER_DEFAULT, %LOCALE_SENGLANGUAGE, BYVAL STRPTR(L$), LEN(L$))
    IF UCASE$(L$) = "FRENCH" THEN FUNCTION = -1
END FUNCTION

'// Static function to save tooltip handle.
FUNCTION zToolTipData (BYVAL hTooltip AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasTooltip AS LONG
    IF RW THEN WasTooltip = hTooltip
    FUNCTION = WasTooltip
END FUNCTION

'// Create or add tooltip
FUNCTION zCreateToolTip (BYVAL hObj AS LONG, zText AS ASCIIZ) AS LONG

    LOCAL hTooltip AS LONG, StyleEx AS LONG, hParent AS LONG, ti AS TOOLINFO

    hParent = GetParent(hObj)
    hTooltip = zToolTipData(0, 0)
    IF hTooltip = 0 THEN
       CALL InitCommonControls()
       StyleEx = 0 ' %WS_EX_TOPMOST ' Instead of 0 to use it with skMsgBox buttons
       hTooltip = CreateWindowEx(StyleEx, _
                             "tooltips_class32", _
                             BYVAL %NULL, _
                             %WS_POPUP OR %TTS_ALWAYSTIP, _
                             %CW_USEDEFAULT, _
                             %CW_USEDEFAULT, _
                             %CW_USEDEFAULT, _
                             %CW_USEDEFAULT, _
                             BYVAL hParent, _
                             BYVAL %NULL, _
                             zInstance, _ 'hinst
                             BYVAL %NULL)
       IF hTooltip THEN
          CALL zToolTipData(hTooltip, 1)
          CALL SendMessage(hTooltip, %TTM_SETTIPTEXTCOLOR, %CAPTION_COLOR_ACTIVE, 0)
          CALL SendMessage(hTooltip, %TTM_SETTIPBKCOLOR, %CAPTION_COLOR_INACTIVE, 0)
          CALL SendMessage(hTooltip, %TTM_SETMAXTIPWIDTH, 0, 400)
       END IF
    END IF
    IF hTooltip THEN
       ti.cbSize   = sizeof(ti)
       ti.hinst    = zInstance
       ti.uFlags   = %TTF_IDISHWND OR %TTF_SUBCLASS
       ti.hWnd     = hParent
       ti.uId      = hObj
     ' Add tooltip now.
       CALL SendMessage(hTooltip, %TTM_ADDTOOL, 0, BYVAL VARPTR(ti))
       CALL zSetToolTipText(hObj, zText)
    END IF
    FUNCTION = hTooltip
END FUNCTION

'// Update tooltip item.
SUB zSetToolTipText (BYVAL hObj AS LONG, zText AS ASCIIZ)
    LOCAL ti AS TOOLINFO
    LOCAL hTooltip AS LONG, sText AS STRING, zLabel AS ASCIIZ * 256
    sText = zText
    REPLACE $zLim WITH $CR IN sText
    zLabel = sText
    hTooltip = zToolTipData(0, 0)
    IF hTooltip THEN
       ti.cbSize   = sizeof(ti)
       ti.hinst    = zInstance
       ti.uFlags   = %TTF_IDISHWND
       ti.hWnd     = GetParent(hObj)
       ti.uId      = hObj
       ti.lpszText = VARPTR(zLabel)
     ' Add tooltip now.
       CALL SendMessage(hTooltip, %TTM_UPDATETIPTEXT, 0, BYVAL VARPTR(ti))
    END IF
END SUB

'// Anchor item detection.
FUNCTION zAnchorItem (BYVAL hWnd AS LONG) AS LONG
    LOCAL Item AS LONG
    IF UBOUND(gProp) > 0 THEN
       ARRAY SCAN gProp(), FROM 1 TO 4, = MKL$(hWnd), TO Item
    END IF
    FUNCTION = Item
END FUNCTION

'// Anchor properties setup.
FUNCTION zSetAnchorMode (BYVAL hWnd AS LONG, BYVAL AnchorMode AS LONG) AS LONG
    LOCAL pZP AS LONG
    IF IsWindow(hWnd) THEN
       LOCAL rc AS RECT, pr AS RECT, p AS POINTAPI

       pZP = zAnchorItem(hWnd)
       IF pZP = 0 THEN ' If the object already exist then we ReUse it
          pZP = MAX&(UBOUND(gProp) + 1, 1)
          REDIM PRESERVE gProp(1 TO pZP) AS ANCHORPROPERTY
       END IF
       gProp(pZP).hWnd = hWnd
       CALL GetWindowRect(hWnd, rc)
       p.X = rc.nLeft: p.Y = rc.nTop
       CALL ScreenToClient(Getparent(hWnd), p)
       CALL GetClientRect(Getparent(hWnd), pr)
       gProp(pZP).anchor     = MIN&(MAX&(AnchorMode, %ANCHOR_NONE), %ANCHOR_CENTER)
       gProp(pZP).rc.nLeft   = p.X
       gProp(pZP).rc.nTop    = p.Y
       gProp(pZP).rc.nRight  = pr.nRight - (rc.nRight - rc.nLeft + p.X)
       gProp(pZP).rc.nBottom = pr.nBottom - (rc.nBottom - rc.nTop + p.Y)

       gProp(pZP).centerx    = p.X - (pr.nRight \ 2)
       gProp(pZP).centery    = p.Y - (pr.nBottom \ 2)

       FUNCTION = -1
    END IF
END FUNCTION

'// Anchor enum callback function.
FUNCTION AnchorEnum (BYVAL hWnd AS LONG, BYVAL lParam AS LONG) AS LONG

    IF IsIconic(zMainWindow(0)) THEN FUNCTION = %FALSE: EXIT FUNCTION ' Stop enumeration

    'LOCAL zChildClass AS ASCIIZ * 32
    LOCAL pr AS RECT, rc AS RECT, pZP AS LONG
    LOCAL x, y, xW, yH AS LONG
    'IF GetClassName(hWnd, zChildClass, SIZEOF(zChildClass)) THEN
       pZP = zAnchorItem(hWnd)
       IF pZP THEN
          IF gProp(pZP).anchor > %ANCHOR_NONE THEN
             CALL GetClientRect(hWnd, rc)
             CALL GetClientRect(GetParent(hWnd), pr)
             x = 0: y = 0: xW = 0: yH = 0
             SELECT CASE LONG gProp(pZP).anchor
            'CASE %ANCHOR_NONE                '= 0
             CASE %ANCHOR_WIDTH               '= 1
                  x&  = gProp(pZP).rc.nLeft
                  y&  = gProp(pZP).rc.nTop
                  xW& = MAX&(pr.nRight - gProp(pZP).rc.nLeft - gProp(pZP).rc.nRight, 0)
                  yH& = rc.nBottom
             CASE %ANCHOR_RIGHT               '= 2
                  x&  = pr.nRight - rc.nRight - gProp(pZP).rc.nRight
                  y&  = gProp(pZP).rc.nTop
                  xW& = rc.nRight
                  yH& = rc.nBottom
             CASE %ANCHOR_CENTER_HORZ         '= 3
                  x&  = (pr.nRight \ 2) + gProp(pZP).centerx
                  y&  = gProp(pZP).rc.nTop
                  xW& = rc.nRight
                  yH& = rc.nBottom
             CASE %ANCHOR_HEIGHT              '= 4
                  x&  = gProp(pZP).rc.nLeft
                  y&  = gProp(pZP).rc.nTop
                  xW& = rc.nRight
                  yH& = MAX&(pr.nBottom - gProp(pZP).rc.nTop - gProp(pZP).rc.nBottom, 0)
             CASE %ANCHOR_HEIGHT_WIDTH        '= 5
                  x& = gProp(pZP).rc.nLeft
                  y& = gProp(pZP).rc.nTop
                  xW& = MAX&(pr.nRight - gProp(pZP).rc.nLeft - gProp(pZP).rc.nRight, 0)
                  yH& = MAX&(pr.nBottom - gProp(pZP).rc.nTop - gProp(pZP).rc.nBottom, 0)
             CASE %ANCHOR_HEIGHT_RIGHT        '= 6
                  x&  = pr.nRight - rc.nRight - gProp(pZP).rc.nRight
                  y&  = gProp(pZP).rc.nTop
                  xW& = rc.nRight
                  yH& = MAX&(pr.nBottom - gProp(pZP).rc.nTop - gProp(pZP).rc.nBottom, 0)
             CASE %ANCHOR_BOTTOM              '= 7
                  x&  = gProp(pZP).rc.nLeft
                  y&  = pr.nBottom - gProp(pZP).rc.nBottom - rc.nBottom
                  xW& = rc.nRight
                  yH& = rc.nBottom
             CASE %ANCHOR_BOTTOM_WIDTH        '= 8
                  x&  = gProp(pZP).rc.nLeft
                  y&  = pr.nBottom - gProp(pZP).rc.nBottom - rc.nBottom
                  xW& = MAX&(pr.nRight - gProp(pZP).rc.nLeft - gProp(pZP).rc.nRight, 0)
                  yH& = rc.nBottom
             CASE %ANCHOR_BOTTOM_RIGHT        '= 9
                  x&  = pr.nRight - rc.nRight - gProp(pZP).rc.nRight
                  y&  = pr.nBottom - gProp(pZP).rc.nBottom - rc.nBottom
                  xW& = rc.nRight
                  yH& = rc.nBottom
             CASE %ANCHOR_CENTER_HORZ_BOTTOM  '= 10
                  x&  = (pr.nRight \ 2) + gProp(pZP).centerx
                  y&  = pr.nBottom - gProp(pZP).rc.nBottom - rc.nBottom
                  xW& = rc.nRight
                  yH& = rc.nBottom
             CASE %ANCHOR_CENTER_VERT         '= 11
                  x&  = gProp(pZP).rc.nLeft
                  y&  = (pr.nBottom - rc.nBottom) \ 2
                  xW& = rc.nRight
                  yH& = rc.nBottom
             CASE %ANCHOR_CENTER_VERT_RIGHT   '= 12
                  x&  = pr.nRight - rc.nRight - gProp(pZP).rc.nRight
                  y&  = (pr.nBottom - rc.nBottom) \ 2
                  xW& = rc.nRight
                  yH& = rc.nBottom
             CASE %ANCHOR_CENTER              '= 13
                  x&  = (pr.nRight - rc.nRight) \ 2
                  y&  = (pr.nBottom \ 2) + gProp(pZP).centery
                  xW& = rc.nRight
                  yH& = rc.nBottom
             END SELECT
             CALL MoveWindow(hWnd, x&, y&, xW&, yH&, 1)
          END IF
       END IF
    'END IF
    FUNCTION = %TRUE ' Continue enumeration of children
END FUNCTION

'// Safe delete for GDI objects.
SUB zDeleteObject (hObject AS LONG)
    IF hObject THEN CALL DeleteObject(hObject): hObject = 0
END SUB

'// Fills a rectangle using a specific color.
SUB zFillRect (BYVAL hGDImageDC AS LONG, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL xW AS LONG, BYVAL yH AS LONG, BYVAL RGBcolor AS LONG)
    LOCAL rc AS Rect, hBrush AS LONG
    CALL SetRect(rc, x, y, x + xW, y + yH)
    hBrush = CreateSolidBrush(RGBcolor)
    CALL FillRect(hGDImageDC, rc, hBrush)
    CALL zDeleteObject(hBrush)
END SUB

TYPE TRIVERTEX
  x AS LONG
  y AS LONG
  Red AS WORD
  Green AS WORD
  Blue AS WORD
  Alpha AS WORD
END TYPE

TYPE GRADIENT_RECT
  UpperLeft AS DWORD
  LowerRight AS DWORD
END TYPE

%GRADIENT_FILL_RECT_H                           = &H00000000
%GRADIENT_FILL_RECT_V                           = &H00000001

'// Set color for gradient fill.
FUNCTION zSetColor (BYVAL ColorByte AS BYTE) AS INTEGER
    FUNCTION = CVI(CHR$(0,ColorByte))
END FUNCTION

'// Gradient fill.
DECLARE FUNCTION GradientFill LIB "MSIMG32.DLL" ALIAS "GradientFill" (BYVAL hdc AS DWORD, pVertex AS TRIVERTEX, BYVAL dwNumVertex AS DWORD, pMesh AS ANY, BYVAL dwNumMesh AS DWORD, BYVAL dwMode AS DWORD) AS LONG
SUB zGradientPaintDC (BYVAL hDC AS LONG, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL xW AS LONG, BYVAL yH AS LONG, BYVAL TopRGB AS LONG, BYVAL BottomRGB AS LONG)
    IF TopRGB = BottomRGB THEN
       CALL zFillRect(hDC, x, y, xW, yH, TopRGB)
    ELSE
       DIM vert(1) AS TRIVERTEX
       DIM gRect AS GRADIENT_RECT
     ' Tile the background
       vert(0).x      = x
       vert(0).y      = y
       vert(0).Red    = zSetColor(zGetRValue(TopRGB))
       vert(0).Green  = zSetColor(zGetGValue(TopRGB))
       vert(0).Blue   = zSetColor(zGetBValue(TopRGB))
       vert(0).Alpha  = &h0000
       vert(1).x      = xW
       vert(1).y      = yH
       vert(1).Red    = zSetColor(zGetRValue(BottomRGB))
       vert(1).Green  = zSetColor(zGetGValue(BottomRGB))
       vert(1).Blue   = zSetColor(zGetBValue(BottomRGB))
       vert(1).Alpha  = &h0000
       gRect.UpperLeft  = 0
       gRect.LowerRight = 1
       CALL GradientFill(hDC, vert(0), 2, gRect, 1, %GRADIENT_FILL_RECT_V)
    END IF
END SUB

'// Create default font.
FUNCTION zDefaultFont () AS LONG
    STATIC hDefault AS LONG
    IF hDefault = 0 THEN hDefault = GetStockObject(%ANSI_VAR_FONT)
    FUNCTION = hDefault
END FUNCTION

'// Set the font being used for a specific control.
SUB zSetCTLFont (BYVAL hCtl AS LONG, BYVAL hFont AS LONG)
    CALL SendMessage(hCtl, %WM_SETFONT, hFont, 0)
END SUB

'// Center text in a static control.
FUNCTION zStaticCenter (BYVAL Label$, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL w AS LONG, BYVAL h AS LONG, BYVAL hParent AS LONG, BYVAL ID AS LONG) AS LONG
    LOCAL hCtl AS LONG
    hCtl = CreateWindowEx(0, "STATIC", (Label$), %WS_CHILD OR %WS_VISIBLE OR %SS_CENTER, _
                           x, y, w, h, hParent, ID, zInstance, BYVAL %NULL)
    CALL zSetCTLFont(hCtl, zDefaultFont)
    FUNCTION = hCtl
END FUNCTION

'// Full file detection.
FUNCTION zExist (zFileSpec AS ASCIIZ) AS LONG
    LOCAL fd AS WIN32_FIND_DATA, hFind AS LONG
    IF LEN(zFileSpec) THEN
       hFind = FindFirstFile(zFileSpec, fd)
       IF hFind <> -1 THEN
          CALL FindClose(hFind&)
          FUNCTION = -1
       END IF
    END IF
END FUNCTION

'// Get Main window private property
FUNCTION zGetMainProperty (BYVAL hWnd AS LONG, BYVAL Item AS LONG) AS LONG
    IF Item > 0 AND Item < %EXTEND_EXTRA + 1 AND IsWindow(hWnd) THEN
       FUNCTION = GetWindowLong(hWnd, (Item - 1) * 4)
    END IF
END FUNCTION

'// Set Main window private property
SUB zSetMainProperty (BYVAL hWnd AS LONG, BYVAL Item AS LONG, BYVAL V AS LONG)
    IF Item > 0 AND Item < %EXTEND_EXTRA + 1 AND IsWindow(hWnd) THEN
       CALL SetWindowLong(hWnd, (Item - 1) * 4, V)
    END IF
END SUB

'// Create DIB section
FUNCTION zCreateDIBSection (BYVAL hDC AS LONG, BYVAL nWidth AS LONG, BYVAL nHeight AS LONG, BYVAL BitCount AS LONG) AS LONG
    LOCAL bi AS MYBITMAPINFO
    bi.bmiHeader.biSize = SIZEOF(bi.bmiHeader)
    bi.bmiHeader.biWidth = nWidth
    bi.bmiHeader.biHeight = nHeight
    bi.bmiHeader.biPlanes = 1
    bi.bmiHeader.biBitCount = BitCount
    bi.bmiHeader.biCompression = %BI_RGB
    FUNCTION = MyCreateDIBSection(hDC, bi, %DIB_RGB_COLORS, 0, 0, 0)
END FUNCTION

'// Get the size of the double buffer private bitmap
SUB zGetBitmapSize (BYVAL hBmp AS LONG, bmW AS LONG, bmH AS LONG)
    LOCAL bm AS BITMAP
    IF hBmp THEN
       CALL GetObject(hBmp, SIZEOF(bm), bm)
       bmW = bm.bmWidth
       bmH = bm.bmHeight
    END IF
END SUB

'// Get the double buffer private bitmap.
FUNCTION zGetPaintBitmap (BYVAL hWnd AS LONG) AS LONG
    FUNCTION = zGetMainProperty(hWnd, %FORM_PaintBitmap)
END FUNCTION

'// Get the double buffer private DC.
FUNCTION zGetPaintDC (BYVAL hWnd AS LONG) AS LONG
    FUNCTION = zGetMainProperty(hWnd, %FORM_PaintDC)
END FUNCTION

'// Create temporary double buffer
FUNCTION zDoubleBuffer(BYVAL hDC AS LONG, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL Action AS LONG) STATIC AS LONG
    DIM Xx AS LONG, Yy AS LONG, UseDC AS LONG, hDCTemp AS LONG, hBMTemp AS LONG, hBMPrev AS LONG
    IF Action THEN
     ' Create OFF screen bitmap to avoid flickering and allow smooth display
     ' ---------------------------------------------------------------------
       hDCTemp = CreateCompatibleDC(hDC)
       hBMTemp = CreateCompatibleBitmap(hDC, x, y)
       hBMPrev = SelectObject(hDCTemp, hBMTemp)
       Xx = x: Yy = y
       UseDC = hDC
       FUNCTION = hDCTemp
    ELSE
     ' End of OFF screen drawing, fast BitBlt to the target display Window
     ' -------------------------------------------------------------------
     ' Draw final result to the target window
       CALL BitBlt(UseDC, x, y, Xx, Yy, hDCTemp, 0, 0, %SRCCOPY)
     ' Deallocate system resources
       CALL SelectObject(hDCTemp, hBMPrev)
       CALL DeleteObject(hBMTemp)
       CALL DeleteDC(hDCTemp)
       FUNCTION = 0
    END IF

END FUNCTION

'// Create permanent double buffer
FUNCTION zPaintToScreen (BYVAL hWnd AS LONG, BYVAL hDC AS LONG, BYVAL X AS LONG, BYVAL Y AS LONG, BYVAL Action AS LONG) AS LONG
    LOCAL rc AS RECT
    LOCAL bmW, bmH, ExistBitmap, hDCTemp, hPaintBitmap AS LONG

    CALL GetClientRect(hWnd, rc)
    IF Action THEN
     ' Create OFF screen bitmap to avoid flickering and allow smooth display
     ' ---------------------------------------------------------------------
       ExistBitmap = zGetPaintBitmap(hWnd)
       IF ExistBitmap THEN
          CALL zGetBitmapSize(ExistBitmap, bmW, bmH)
          IF MAX&(rc.nRight, X) < bmW + 1 AND MAX&(rc.nBottom, Y) < bmH + 1 THEN
             FUNCTION = zGetPaintDC(hWnd): EXIT FUNCTION
          END IF
          CALL zDeleteObject(ExistBitmap)
          CALL DeleteDC(zGetPaintDC(hWnd))
       END IF
       hDCTemp = CreateCompatibleDC(hDC)

       hPaintBitmap = zCreateDIBSection(hDC, MAX&(rc.nRight, X), MAX&(rc.nBottom, Y), 32)

       CALL SelectObject(hDCTemp, hPaintBitmap)
       CALL zSetMainProperty(hWnd, %FORM_PaintDC, hDCTemp)
       CALL zSetMainProperty(hWnd, %FORM_PaintBitmap, hPaintBitmap)
       FUNCTION = hDCTemp
    ELSE
     ' End of OFF screen drawing, fast BitBlt to the target display Window
     ' -------------------------------------------------------------------
     ' Draw final result to the target window
       CALL BitBlt(hDC, X, Y, rc.nRight, rc.nBottom, zGetPaintDC(hWnd), 0, 0, %SRCCOPY)
    END IF

END FUNCTION

'// To perform immediate redraw of any Windows control.
SUB zUpdateWindow (BYVAL hWnd AS LONG, BYVAL FlagMode AS LONG)
    CALL InvalidateRect(hWnd, BYVAL 0&, FlagMode)
    CALL UpdateWindow(hWnd)
END SUB

'// We process our custom system buttons command there.
FUNCTION zButtonSysCommand (BYVAL hWnd AS LONG, BYVAL wParam AS LONG) AS LONG
    LOCAL Done AS LONG
    Done = 0
    SELECT CASE LONG CINT(LOWRD(wParam))
    CASE %ID_CLOSE
         CALL SendMessage(hWnd, %WM_CLOSE, 0, 0)
         Done = -1
    CASE %ID_MAXIMIZE
         CALL ShowWindow(hWnd, %SW_MAXIMIZE)
         CALL ShowWindow(GetDlgItem(hWnd, %ID_RESTORE), %SW_SHOW)
         CALL ShowWindow(GetDlgItem(hWnd, %ID_MAXIMIZE), %SW_HIDE)

         CALL EnumChildWindows(hWnd, CODEPTR(AnchorEnum), 0)
         CALL zDrawBackground()

         Done = -1
    CASE %ID_RESTORE
         CALL ShowWindow(GetDlgItem(hWnd, %ID_MAXIMIZE), %SW_SHOW)
         CALL ShowWindow(GetDlgItem(hWnd, %ID_RESTORE), %SW_HIDE)
         CALL zUpdateWindow(GetDlgItem(hWnd, %ID_MAXIMIZE), 0)
         CALL ShowWindow(hWnd, %SW_RESTORE)

         CALL EnumChildWindows(hWnd, CODEPTR(AnchorEnum), 0)
         CALL zDrawBackground()

         Done = -1
    CASE %ID_MINIMIZE
         CALL ShowWindow(hWnd, %SW_MINIMIZE)
         Done = -1
    END SELECT
    FUNCTION = Done
END FUNCTION

'// To check KEY or MOUSE button state.
FUNCTION zIsKeyDown (BYVAL CheckKey AS LONG) AS LONG
    LOCAL KeyDown AS LONG
    KeyDown = GetAsyncKeyState(CheckKey)
    FUNCTION = BIT(KeyDown, 15)
END FUNCTION

'// To check SHIFT key state.
FUNCTION zIsShiftKeyPressed () AS LONG
    FUNCTION = zIsKeyDown(16)
END FUNCTION

'// To check CTRL key state.
FUNCTION zIsCtrlKeyPressed () AS LONG
    FUNCTION = zIsKeyDown(17)
END FUNCTION

'// To check the left mouse button state.
FUNCTION zIsLButtonDown () AS LONG
    FUNCTION = zIsKeyDown(1)
END FUNCTION

'// To check the right mouse button state.
FUNCTION zIsRButtonDown () AS LONG
    FUNCTION = zIsKeyDown(2)
END FUNCTION

'// Static property to save previous procedure being used by the button's superclass
FUNCTION zButOldProc (BYVAL OldProc AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasOldProc AS LONG
    IF RW THEN WasOldProc = OldProc
    FUNCTION = WasOldProc
END FUNCTION

'// Static property to store the previous size of the wc.cbWndExtra class member.
FUNCTION zButOldExtra (BYVAL OldExtra AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasOldExtra AS LONG
    IF RW THEN WasOldExtra = OldExtra \ 4
    FUNCTION = WasOldExtra
END FUNCTION

'// Get button's property.
FUNCTION zGetButProperty (BYVAL hWnd AS LONG, BYVAL Item AS LONG) AS LONG
    IF Item > 0 AND Item < %EXTEND_EXTRA + 1 AND IsWindow(hWnd) THEN
       FUNCTION = GetWindowLong(hWnd, (zButOldExtra(0, 0) + Item - 1) * 4)
    END IF
END FUNCTION

'// Get button's image property.
FUNCTION zGetButImage (BYVAL hWnd AS LONG) AS LONG
    FUNCTION = zGetButProperty(hWnd, %BUTTON_Image)
END FUNCTION

'// Get button's style property.
FUNCTION zGetButStyle (BYVAL hWnd AS LONG) AS LONG
    FUNCTION = zGetButProperty(hWnd, %BUTTON_Style)
END FUNCTION

'// Set button's property.
SUB zSetButProperty (BYVAL hWnd AS LONG, BYVAL Item AS LONG, BYVAL V AS LONG)
    IF Item > 0 AND Item < %EXTEND_EXTRA + 1 AND IsWindow(hWnd) THEN
       CALL SetWindowLong(hWnd, (zButOldExtra(0, 0) + Item - 1) * 4, V)
    END IF
END SUB

'// Return width and height size of a GDIPLUS image.
SUB zGetImageSize (BYVAL Img AS LONG, imgW AS LONG, imgH AS LONG)
    CALL GdipGetImageWidth(Img, imgW)
    CALL GdipGetImageHeight(Img, imgH)
END SUB

'// Create GDIPLUS image from any of the supported graphic format.
'// I mainly use full 32-bit PNG with transparent section and/or variable opacity
FUNCTION zCreateImageFromFile (zFullName AS ASCIIZ) AS LONG
    LOCAL So, ImageType, Img AS LONG
    So = INSTR(-1, zFullName, $Dot)
    IF NOT zExist(zFullName) THEN So = 0
    IF So THEN
       ImageType = INSTR($GDIPLUSEXT, UCASE$(MID$(zFullName, So)) + $Dot)
       IF ImageType THEN
        ' Load the image
          IF GdipLoadImageFromFile((UCODE$(zFullName)), Img) = 0 THEN
             FUNCTION = Img
          END IF
       END IF
    END IF
END FUNCTION

SUB zDisposeImage (BYREF Img AS LONG)
    IF Img THEN CALL GdipDisposeImage(Img): Img = 0
END SUB

'// Create an image button control
FUNCTION zButImage (BYVAL hOwner AS LONG, zFullpathImageName AS ASCIIZ, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL ButID AS LONG) AS LONG
    LOCAL wc  AS WNDCLASSEX
    LOCAL zClass AS ASCIIZ * 10
    LOCAL hBut, IsInitialized AS LONG

    zClass = "ZBUTIMAGE"
    wc.cbSize = SIZEOF(wc)
    IsInitialized = GetClassInfoEx(zInstance, zClass, wc)
    IF IsInitialized = 0 THEN
       IsInitialized = GetClassInfoEx(%NULL, "BUTTON", wc)
       IF IsInitialized THEN
          CALL zButOldProc(wc.lpfnWndProc, 1)
          CALL zButOldExtra(wc.cbWndExtra, 1)
          wc.lpfnWndProc   = CODEPTR(zImageButProc)
          '// %EXTEND_EXTRA
          '// We reserve %EXTEND_EXTRA bytes to easily store pivate properties
          '// that can be retrieved using: zSetButProperty and zGetButProperty
          wc.cbWndExtra    = wc.cbWndExtra + (%EXTEND_EXTRA * 4)
          wc.hInstance     = zInstance
          wc.lpszClassName = VARPTR(zClass)
          IsInitialized =  RegisterClassEx(wc)
       END IF
    END IF

    IF IsInitialized THEN
       LOCAL Img AS LONG
'      // Create GDIPLUS image from file
       Img = zCreateImageFromFile(zFullpathImageName)
       IF Img THEN
          LOCAL btW, btH, imgW, imgH AS LONG
'         // Get the GDIPLUS image size
          CALL zGetImageSize(Img, imgW, imgH)
          IF ButID = %ID_LED THEN
             btW = imgW \ 2
          ELSE
             btW = imgW \ 5
          END IF
          btH = imgH
          Style& = %WS_CHILD OR %WS_VISIBLE OR %WS_TABSTOP ' OR %BS_OWNERDRAW
          hBut = CreateWindowEx(%WS_EX_TRANSPARENT, zClass, "", Style&, x, y, btW, btH, hOwner, ButID, zInstance, BYVAL %NULL)
          IF hBut THEN
'            // Save Img handle as a property
             CALL zSetButProperty(hBut, %BUTTON_Style, %BS_BITMAP)
             CALL zSetButProperty(hBut, %BUTTON_Image, Img)
             FUNCTION = hBut
          ELSE
'            // Delete image
             CALL zDisposeImage(Img)
          END IF
       END IF
    END IF
END FUNCTION

FUNCTION zDisplayDC() AS LONG
    FUNCTION = CreateIC("DISPLAY", BYVAL 0, BYVAL 0, BYVAL 0)
END FUNCTION

'// Create new Main form region on the fly
SUB zCreateFormRegion(BYVAL TransColor AS LONG)

    LOCAL bm AS BITMAP
    LOCAL rdh AS RGNDATAHEADER PTR
    LOCAL lpRect AS RECT PTR
    LOCAl hRgn1 AS LONG, hRgn2 AS LONG, TT AS LONG, MaxRegions AS LONG, sRegionData AS STRING
    LOCAL hDIB, I, J, K, M, IsSame AS LONG

    hDIB = zGetPaintBitmap(zMainWindow(0)): IF hDIB = 0 THEN EXIT SUB

    MaxRegions = 4000

    CALL GetObject(hDIB, SIZEOF(bm), bm)
    REDIM Ar(0) AS LONG AT bm.bmBits

  ' Set up the transparent color
    IF TransColor = -1 THEN ' Common Trancolor is magenta &HFF00FF
       TransColor = (Ar((bm.bmHeight - 1) * bm.bmWidth) AND &HFFFFFF)'<--- (0, 0)
    END IF

    sRegionData = STRING$(LEN(RGNDATAHEADER) + LEN(RECT) * MaxRegions, 0)
    rdh = STRPTR(sRegionData)
    @rdh.nCount = MaxRegions + 1
    @rdh.dwSize = LEN(RGNDATAHEADER)
    @rdh.iType = %RDH_RECTANGLES
    @rdh.rcBound.nLeft = 0
    @rdh.rcBound.nTop = 0
    @rdh.rcBound.nRight = bm.bmWidth
    @rdh.rcBound.nBottom = bm.bmHeight
    FOR J = 0 TO bm.bmHeight - 1
        TT = bm.bmWidth * (bm.bmHeight - 1 - J): M = -1
        FOR I = 0 TO bm.bmWidth
            IF I = bm.bmWidth THEN K = TransColor ELSE K = (Ar(TT) AND &HFFFFFF): INCR TT

            IF K = TransColor THEN IsSame = -1 ELSE IsSame = 0

            IF IsSame = 0 THEN
               IF M = -1 THEN M = I
            ELSEIF M >= 0 THEN
               IF @rdh.nCount >= MaxRegions THEN
                  hRgn2 = ExtCreateRegion(BYVAL 0, LEN(RGNDATAHEADER) + (LEN(RECT) * @rdh.nCount), BYVAL rdh)
                  IF hRgn1 = 0 THEN
                     hRgn1 = hRgn2
                  ELSE
                     CALL CombineRgn(hRgn1, hRgn1, hRgn2, %RGN_OR)
                     CALL zDeleteObject(hRgn2)
                  END IF
                  lpRect = LEN(RGNDATAHEADER) + rdh
                  @rdh.nCount = 0
               END IF
               INCR @rdh.nCount
               @lpRect.nLeft = M
               @lpRect.nRight = I
               @lpRect.nTop = J
               @lpRect.nBottom = J + 1
               lpRect = lpRect + LEN(RECT)
               M = -1
            END IF
        NEXT
    NEXT
    hRgn2 = ExtCreateRegion(BYVAL 0, LEN(RGNDATAHEADER) + (LEN(RECT) * @rdh.nCount), BYVAL rdh)
    IF hRgn1 = 0 THEN
       hRgn1 = hRgn2
    ELSE
       CALL CombineRgn(hRgn1, hRgn1, hRgn2, %RGN_OR)
       CALL DeleteObject(hRgn2)
    END IF

    IF hRgn1 THEN CALL SetWindowRgn(zMainWindow(0), hRgn1, %TRUE)

END SUB

'// Paint image in tiling mode
SUB zTilePaint (BYVAL graphics AS LONG, BYVAL Img AS LONG, BYVAL xOffset AS LONG, BYVAL yOffset AS LONG, BYVAL nPaintWidth AS LONG, BYVAL nPaintHeight AS LONG)
    IF Img THEN
       LOCAL Rows, Cols, x, y, dx, dy, ImgW, ImgH, WasImgW, ImgAttr AS LONG
       CALL zGetImageSize(Img, ImgW, ImgH)
'      // Calc number of rows and columns to paint.
       IF ImgW THEN Rows = nPaintWidth \ ImgW: IF Rows * ImgW < nPaintWidth THEN Rows = Rows + 1
       IF ImgH THEN Cols = nPaintHeight \ ImgH: IF Cols * ImgH < nPaintHeight THEN Cols = Cols + 1
'      // Spray out across destination.
       WasImgW = ImgW
       FOR y = 1 TO Cols
           IF dy + ImgH > nPaintHeight THEN ImgH = nPaintHeight - dy
           dx = 0: ImgW = WasImgW
           FOR x = 1 TO Rows
               IF dx + ImgW > nPaintWidth THEN ImgW = nPaintWidth - dx
               CALL GdipDrawImageRectRectI(graphics, Img, xOffset + dx, yOffset + dy, ImgW, ImgH, _
                                           0, 0, ImgW, ImgH, %UnitPixel, ImgAttr)
               dx = dx + ImgW
           NEXT
           dy = dy + ImgH
       NEXT
    END IF
END SUB    

'// Paint our custom background there
SUB zPaintBackground()
    LOCAL hMain AS LONG, hIC AS LONG, hDC AS LONG, rc AS RECT
    LOCAL graphics, Img, ImgW, ImgH, Wider, ImgAttr, TilingMode AS LONG

    hMain = zMainWindow(0)
    IF IsIconic(hMain) THEN EXIT SUB

    CALL GetClientRect(hMain, rc)
    hIC = zDisplayDC()
    hDC = zPaintToScreen(hMain, hIC, rc.nRight, rc.nBottom, 1)

    IF GdipCreateFromHDC(hDC, graphics) = 0 THEN
'      // Wider is being used to compensate the stretching mode
       Wider = 20
       TilingMode = %TRUE

'      // paint first the center
       Img = zGetMainProperty(hMain, %FORM_Center): CALL zGetImageSize(Img, ImgW, ImgH)
       IF TilingMode THEN '// Paint in tiling mode
          CALL zTilePaint(graphics, Img, 0, 0, rc.nRight, rc.nBottom)
       ELSE '              // Paint in stretch mode
          CALL GdipDrawImageRectRectI(graphics, Img, 0, 0, rc.nRight + Wider, rc.nBottom + Wider, _
                                      0, 0, ImgW, ImgH, %UnitPixel, ImgAttr)
       END IF

       LOCAL ImgTL, TLW, TLH AS LONG
       ImgTL = zGetMainProperty(hMain, %FORM_TopLeft): CALL zGetImageSize(ImgTL, TLW, TLH)
       LOCAL ImgTR, TRW, TRH AS LONG
       ImgTR = zGetMainProperty(hMain, %FORM_TopRight): CALL zGetImageSize(ImgTR, TRW, TRH)
       LOCAL ImgBL, BLW, BLH AS LONG
       ImgBL = zGetMainProperty(hMain, %FORM_BottomLeft): CALL zGetImageSize(ImgBL, BLW, BLH)
       LOCAL ImgBR, BRW, BRH AS LONG
       ImgBR = zGetMainProperty(hMain, %FORM_BottomRight): CALL zGetImageSize(ImgBR, BRW, BRH)

'      // paint top side
       Img = zGetMainProperty(hMain, %FORM_TopSide): CALL zGetImageSize(Img, ImgW, ImgH)
       'CALL GdipDrawImageRectRectI(graphics, Img, 0, 0, rc.nRight + Wider, ImgH, _
       '                            0, 0, ImgW, ImgH, %UnitPixel, ImgAttr)
       CALL zTilePaint(graphics, Img, TLW, 0, rc.nRight - (TLW + TRW), ImgH)

'      // paint bottom side
       Img = zGetMainProperty(hMain, %FORM_BottomSide): CALL zGetImageSize(Img, ImgW, ImgH)
       'CALL GdipDrawImageRectRectI(graphics, Img, 0, rc.nBottom - ImgH, rc.nRight + Wider, ImgH, _
       '                            0, 0, ImgW, ImgH, %UnitPixel, ImgAttr)
       CALL zTilePaint(graphics, Img, BLW, rc.nBottom - BLH, rc.nRight - (BLW + BRW), ImgH)

'      // paint left side
       Img = zGetMainProperty(hMain, %FORM_SideLeft): CALL zGetImageSize(Img, ImgW, ImgH)
       'CALL GdipDrawImageRectRectI(graphics, Img, 0, 0, ImgW, rc.nBottom + Wider, _
       '                            0, 0, ImgW, ImgH, %UnitPixel, ImgAttr)
       CALL zTilePaint(graphics, Img, 0, TLH, ImgW, rc.nBottom - (TLH + BLW))

'      // paint right side
       Img = zGetMainProperty(hMain, %FORM_SideRight): CALL zGetImageSize(Img, ImgW, ImgH)
       'CALL GdipDrawImageRectRectI(graphics, Img, rc.nRight - ImgW, 0, ImgW, rc.nBottom + Wider, _
       '                            0, 0, ImgW, ImgH, %UnitPixel, ImgAttr)
       CALL zTilePaint(graphics, Img, rc.nRight - ImgW, TRH, ImgW, rc.nBottom - (TRH + BRH))

'      // paint top left
       CALL GdipDrawImageRectRectI(graphics, ImgTL, 0, 0, TLW, TLH, _
                                   0, 0, TLW, TLH, %UnitPixel, ImgAttr)
'      // paint top right
       CALL GdipDrawImageRectRectI(graphics, ImgTR, rc.nRight - TRW, 0, TRW, TRH, _
                                   0, 0, TRW, TRH, %UnitPixel, ImgAttr)
'      // paint bottom left
       CALL GdipDrawImageRectRectI(graphics, ImgBL, 0, rc.nBottom - BLH, BLW, BLH, _
                                   0, 0, BLW, BLH, %UnitPixel, ImgAttr)
'      // paint bottom right
       CALL GdipDrawImageRectRectI(graphics, ImgBR, rc.nRight - BRW, rc.nBottom - BRH, BRW, BRH, _
                                   0, 0, BRW, BRH, %UnitPixel, ImgAttr)
'      // paint icon
'      // Note: that we could use PNG icon either.
       IF GdipCreateBitmapFromHICON(LoadIcon(zInstance, "PROGRAM"), Img) = 0 THEN
          CALL zGetImageSize(Img, ImgW, ImgH)
          CALL GdipDrawImageRectRectI(graphics, Img, %ICON_X_LOCATION, %ICON_Y_LOCATION, %ICON_SIZE, %ICON_SIZE, _
                                      0, 0, ImgW, ImgH, %UnitPixel, ImgAttr)
          CALL zDisposeImage(Img)
       END IF

       CALL GdipDeleteGraphics(graphics)
    END IF

'   // Paint caption text
    CALL zDrawTextToDC(hDC, (zGetCTLText(hMain)), %CAPTION_X, %CAPTION_Y, zColorARGB(255, gColorCaption), $CAPTION_FONT, %CAPTION_FONT_HEIGHT, -1, 0) 

'   // WP_PRINT and WM_PRINCLIENT is very valuable for double buffering technic
    'lParam& = %PRF_CLIENT OR %PRF_CHILDREN OR %PRF_NONCLIENT OR %PRF_ERASEBKGND OR %PRF_CHECKVISIBLE OR %PRF_OWNED
    lParam& = %PRF_CLIENT OR %PRF_CHILDREN OR %PRF_NONCLIENT OR %PRF_CHECKVISIBLE 'OR %PRF_OWNED
    CALL SendMessage(hMain, %WM_PRINT, hDC, lParam&)

    CALL DeleteDC(hIC)
END SUB

'// Draw our custom background there
SUB zDrawBackground()
    LOCAL hMain AS LONG, sUseText AS STRING

    hMain = zMainWindow(0)
    IF IsIconic(hMain) THEN EXIT SUB

'   // Paint custom background
    CALL zPaintBackground()
'   // We use Magenta color, -1 means use the top left pixel color at coordinate 0,0.
    CALL zCreateFormRegion(&hFF00FF) ' &HFF00FF = Magenta color

END SUB

'// Draw button text
FUNCTION zDrawButtonText( _
         BYVAL graphics AS LONG, _
         zUseText AS ASCIIZ, _
         BYVAL xW AS LONG, _
         BYVAL yH AS LONG, _
         BYVAL ColrARGB AS LONG, _
         zUseFont AS ASCIIZ, _
         BYVAL UseSize AS LONG, _
         BYVAL Use3D AS LONG, _
         BYVAL UseStrFormat AS LONG) AS LONG
    LOCAL layoutRect  AS RECTF
    LOCAL boundingBox AS RECTF
    LOCAl x, y, nRet, strFormat, Fam, TempFont, zdW, zdH AS LONG
    LOCAL sUseText, sUseFont, sLabel AS STRING

    sUseText = zUseText: sUseFont = zUseFont

  ' Create matching font
    CALL GdipCreateFontFamilyFromName((UCODE$(sUseFont)), 0, Fam)
    IF Fam THEN
       CALL GdipCreateFont(Fam, UseSize, %FontStyleRegular, %UnitPixel, TempFont)
       IF TempFont THEN
        ' Shadow offset use NULL if you don't want a shadow,
        ' use positive value to display shadow right, negative value to display shadow left
        ' Draw the string
          CALL GdipCreateStringFormat(0, 0, strFormat)
          sLabel = TRIM$(sUseText, ANY CHR$(0,32))
          CALL GdipMeasureString(graphics, (UCODE$(sLabel)), LEN(sLabel), TempFont, layoutRect, strFormat, boundingBox, BYVAL %NULL, BYVAL %NULL)
          CALL GdipDeleteStringFormat(strFormat)
          zdW   = CLNG(boundingBox.nRight + .5)
          zdH   = CLNG(boundingBox.nBottom + .5)' + 1.5)
          x = MAX&((xW - zdW) \ 2, 0)
          y = MAX&((yH - zdH) \ 2, 0) + 1
          nRet = zDrawStringFormatedEx(graphics, _
                                       sUseText, _
                                       x, y, _
                                       zdW, zdH, _
                                       ColrARGB, _
                                       %TextRenderingHintAntiAlias, _
                                       TempFont, _
                                       Use3D, _
                                       UseStrFormat)
          CALL GdipDeleteFont(TempFont) ' Delete the font object
       END IF
       CALL GdipDeleteFontFamily(Fam)   ' Delete the font family object
    END IF
    FUNCTION = nRet
END FUNCTION

'// Image button procedure
FUNCTION zImageButProc (BYVAL hWnd AS LONG, BYVAL Msg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) AS LONG
    LOCAL hDC, Img, ImgW, ImgH, graphics, ImgAttr, UseState AS LONG
    LOCAL rw AS RECT, rc AS RECT, lp AS POINTAPI, ButtonStyle AS LONG
    SELECT CASE LONG Msg

    CASE %WM_PAINT, %WM_PRINT
         Img = zGetButImage(hWnd)
         IF Img THEN
            LOCAL ps AS PAINTSTRUCT

            ButtonStyle = zGetButStyle(hWnd)     

            CALL GetClientRect(hWnd, rc)
            IF Msg = %WM_PAINT THEN
               hDC = BeginPaint(hWnd, ps)
               IF ButtonStyle <> %BS_GROUPBOX THEN
'                 // If the parent is the main form then we use double buffer
'                 // and we paint first the form background.
                  IF GetParent(hWnd) = zMainWindow(0) THEN
                     hDC = zDoubleBuffer(hDC, rc.nRight, rc.nBottom, 1)
                     CALL GetWindowRect(hWnd, rw)
                     lp.x = rw.nLeft: lp.y = rw.nTop
                     CALL ScreenToClient(GetParent(hWnd), lp)
                     CALL BitBlt(hDC, 0, 0, rc.nRight, rc.nBottom, zGetPaintDC(zMainWindow(0)), lp.x, lp.y, %SRCCOPY)
                  END IF
               END IF
            ELSE ' // WM_PRINT
               hDC = wParam
            END IF
            IF GdipCreateFromHDC(hDC, graphics) = 0 THEN
               CALL GetWindowRect(hWnd, rw)
               lp.x = rw.nLeft: lp.y = rw.nTop
               CALL ScreenToClient(GetParent(hWnd), lp)
               CALL zGetImageSize(Img, ImgW, ImgH)
               IF GetDlgCtrlID(hWnd) = %ID_LED THEN
                  ImgW = ImgW \ 2
                  IF zMainWindow(0) = GetForegroundWindow THEN 
                     UseState = 1
                  ELSE
                     UseState = 2
                  END IF
               ELSE
                  ImgW = ImgW \ 5
                  IF IsWindowEnabled(hWnd) THEN
                     UseState = 1: IF hWnd = GetFocus() THEN UseState = 4
                     CALL GetCursorPos(lp)
                     CALL ScreenToClient(hWnd, lp)
                     IF PtInRect(rc, lp.x, lp.y) THEN
                        IF zIsLButtonDown() THEN
                           IF hWnd = GetFocus() THEN
                              IF GetCursor() = LoadCursor(%NULL, BYVAL %IDC_ARROW) THEN UseState = 2
                           END IF
                        ELSE
                           UseState = 5
                        END IF
                     END IF
                  ELSE
                     UseState = 3
                  END IF
               END IF
               
               IF ButtonStyle = %BS_PUSHBUTTON THEN
                  CALL zPaintButton(graphics, UseState, Img, 0, 0, rc.nRight, rc.nBottom, ButtonStyle)
                  LOCAL sUseText AS STRING, nTextColor AS LONG
                  sUseText = zGetCTLText(hWnd)
                  IF LEN(sUseText) THEN
                     nTextColor = zGetButProperty(hWnd, %BUTTON_TEXT_COLOR)
                     IF IsWindowEnabled(hWnd) = %FALSE THEN
                        CALL zSplitColorARGB(nTextColor, A?, R?, G?, B?)
                        nTextColor = zColorARGB(64, RGB(A?, R?, B?))
                     END IF
                     CALL zDrawButtonText(graphics, (sUseText), _ 
                                          rc.nRight, rc.nBottom, _
                                          nTextColor, _             ' ARGB color
                                          $CAPTION_FONT, _          ' The font to use
                                          %BUTPUSH_FONT_SIZE, _     ' font size
                                          -1, _                     ' 3D effect
                                          0)
                  END IF
               ELSEIF ButtonStyle = %BS_GROUPBOX THEN
                  CALL zPaintButton(graphics, 1, Img, 0, 0, rc.nRight, rc.nBottom, ButtonStyle)
               
               ELSE '                  %BS_BITMAP
                  CALL GdipDrawImageRectRectI(graphics, Img, _
                                              0, 0, ImgW, ImgH, _
                                              ImgW * UseState - ImgW, 0, ImgW, ImgH, %UnitPixel, _
                                              ImgAttr)
               END IF

               CALL GdipDeleteGraphics(graphics)
            END IF
            IF Msg = %WM_PAINT THEN
               IF ButtonStyle <> %BS_GROUPBOX THEN
                  IF GetParent(hWnd) = zMainWindow(0) THEN
                     CALL zDoubleBuffer(0, 0, 0, 0)
                  END IF
               END IF
               CALL EndPaint(hWnd, ps)
            END IF
            
            FUNCTION = 0: EXIT FUNCTION
         END IF
    CASE %WM_DESTROY
'        // Delete the GDIPLUS button image
         CALL zDisposeImage(zGetButImage(hWnd))
    END SELECT

    FUNCTION  = CallWindowProc(zButOldProc(0,0), hWnd, Msg, wParam, lParam)

END FUNCTION

'// Main window minimum horizontal track size
FUNCTION zMinTrackSizeX(BYVAL SizeX AS LONG) AS LONG
    STATIC WasSizeX AS LONG
    IF SizeX THEN WasSizeX = SizeX
    FUNCTION = WasSizeX
END FUNCTION

'// Main window minimum vertical track size
FUNCTION zMinTrackSizeY(BYVAL SizeY AS LONG) AS LONG
    STATIC WasSizeY AS LONG
    IF SizeY THEN WasSizeY = SizeY
    FUNCTION = WasSizeY
END FUNCTION

'// This procedure is being used to paint the push-buttons.
SUB zPaintButton(BYVAL gDest AS LONG, BYVAL UseState AS LONG, BYVAL ImgSrce AS LONG, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL xW AS LONG, BYVAL yH AS LONG, ButtonStyle AS LONG)

    LOCAL imgW, imgH, Xm, Ym, gSrce, ImgAttr, xOffset AS LONG

    CALL zGetImageSize(ImgSrce, imgW, imgH)
    IF ButtonStyle = %BS_PUSHBUTTON THEN imgW = imgW \ 5

    Xm = %BUTPUSH_FIXED_SIZE_X ' Horizontal fixed border size for stretched pushbutton
    Ym = %BUTPUSH_FIXED_SIZE_Y ' Vertical fixed border size for stretched pushbutton

    xOffset = imgW * UseState - imgW

  ' Horizontal up
    CALL GdipDrawImageRectRectI(gDest, ImgSrce, _
                                x + xW - Xm, y, Xm, Ym, _
                                imgW * UseState - Xm, 0, Xm, Ym, _
                                %UnitPixel, ImgAttr)
    CALL GdipDrawImageRectRectI(gDest, ImgSrce, _
                                x + Xm, y, xW - Xm * 2, Ym, _
                                imgW * UseState - imgW + Xm, 0, imgW - Xm * 2, Ym, _
                                %UnitPixel, ImgAttr)
  ' Vertical left
    CALL GdipDrawImageRectRectI(gDest, ImgSrce, _
                                x, y, Xm, Ym, _
                                imgW * UseState - imgW, 0, Xm, Ym, _
                                %UnitPixel, ImgAttr)
    CALL GdipDrawImageRectRectI(gDest, ImgSrce, _
                                x, y + Ym, Xm, yH - Ym * 2, _
                                imgW * UseState - imgW, Ym, Xm, imgH - Ym * 2, _
                                %UnitPixel, ImgAttr)
    CALL GdipDrawImageRectRectI(gDest, ImgSrce, _
                                x, y + yH - Ym, Xm, Ym, _
                                imgW * UseState - imgW, imgH - Ym, Xm, Ym, _
                                %UnitPixel, ImgAttr)

  ' Middle button (draw the whole surface except the pixels border)
    CALL GdipDrawImageRectRectI(gDest, ImgSrce, _
                                x + Xm, y + Ym, xW - Xm * 2, yH - Ym * 2, _
                                imgW * UseState - imgW + Xm, 0 + Ym, imgW - Xm * 2, imgH - Ym * 2, _
                                %UnitPixel, ImgAttr)

  ' Horizontal down
    CALL GdipDrawImageRectRectI(gDest, ImgSrce, _
                                x + Xm, y + yH - Ym, xW - Xm * 2, Ym, _
                                imgW * UseState - imgW + Xm, imgH - Ym, imgW - Xm * 2, Ym, _
                                %UnitPixel, ImgAttr)
  ' Vertical right
    CALL GdipDrawImageRectRectI(gDest, ImgSrce, _
                                x + xW - Xm, y + Ym, Xm, yH - Ym * 2, _
                                imgW * UseState - Xm, Ym, Xm, imgH - Ym * 2, _
                                %UnitPixel, ImgAttr)
    CALL GdipDrawImageRectRectI(gDest, ImgSrce, _
                                x + xW - Xm, y + yH - Ym, Xm, Ym, _
                                imgW * UseState - Xm, imgH - Ym, Xm, Ym, _
                                %UnitPixel, ImgAttr)
END SUB

'// Create a frame button control
FUNCTION zFrameButton (BYVAL hOwner AS LONG, zFullpathImageName AS ASCIIZ, zLabel AS ASCIIZ, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL xW AS LONG, BYVAL yH AS LONG, BYVAL ButID AS LONG) AS LONG
    LOCAL wc  AS WNDCLASSEX
    LOCAL zClass AS ASCIIZ * 10
    LOCAL hBut, IsInitialized AS LONG

    zClass = "ZBUTIMAGE"
    wc.cbSize = SIZEOF(wc)
    IsInitialized = GetClassInfoEx(zInstance, zClass, wc)
    IF IsInitialized = 0 THEN
       IsInitialized = GetClassInfoEx(%NULL, "BUTTON", wc)
       IF IsInitialized THEN
          CALL zButOldProc(wc.lpfnWndProc, 1)
          CALL zButOldExtra(wc.cbWndExtra, 1)
          wc.lpfnWndProc   = CODEPTR(zImageButProc)
          '// %EXTEND_EXTRA
          '// We reserve %EXTEND_EXTRA bytes to easily store pivate properties
          '// that can be retrieved using: zSetButProperty and zGetButProperty
          wc.cbWndExtra    = wc.cbWndExtra + (%EXTEND_EXTRA * 4)
          wc.hInstance     = zInstance
          wc.lpszClassName = VARPTR(zClass)
          IsInitialized =  RegisterClassEx(wc)
       END IF
    END IF

    IF IsInitialized THEN
       LOCAL Img AS LONG
'      // Create GDIPLUS image from file
       Img = zCreateImageFromFile(zFullpathImageName)
       IF Img THEN
          Style& = %WS_CHILD OR %WS_VISIBLE OR %WS_DISABLED 
          hBut = CreateWindowEx(%WS_EX_TRANSPARENT, zClass, zLabel, Style&, x, y, xW, yH, hOwner, ButID, zInstance, BYVAL %NULL)
          IF hBut THEN
'            // Save Img handle as a property
             CALL zSetButProperty(hBut, %BUTTON_Style, %BS_GROUPBOX)
             CALL zSetButProperty(hBut, %BUTTON_Image, Img)
             FUNCTION = hBut
          ELSE
'            // Delete image
             CALL zDisposeImage(Img)
          END IF
       END IF
    END IF
END FUNCTION

'// Create a push button control
FUNCTION zPushButton (BYVAL hOwner AS LONG, zFullpathImageName AS ASCIIZ, zLabel AS ASCIIZ, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL xW AS LONG, BYVAL yH AS LONG, BYVAL ButID AS LONG, BYVAL ARGBColor AS LONG) AS LONG
    LOCAL wc  AS WNDCLASSEX
    LOCAL zClass AS ASCIIZ * 10
    LOCAL hBut, IsInitialized AS LONG

    zClass = "ZBUTIMAGE"
    wc.cbSize = SIZEOF(wc)
    IsInitialized = GetClassInfoEx(zInstance, zClass, wc)
    IF IsInitialized = 0 THEN
       IsInitialized = GetClassInfoEx(%NULL, "BUTTON", wc)
       IF IsInitialized THEN
          CALL zButOldProc(wc.lpfnWndProc, 1)
          CALL zButOldExtra(wc.cbWndExtra, 1)
          wc.lpfnWndProc   = CODEPTR(zImageButProc)
          '// %EXTEND_EXTRA
          '// We reserve %EXTEND_EXTRA bytes to easily store pivate properties
          '// that can be retrieved using: zSetButProperty and zGetButProperty
          wc.cbWndExtra    = wc.cbWndExtra + (%EXTEND_EXTRA * 4)
          wc.hInstance     = zInstance
          wc.lpszClassName = VARPTR(zClass)
          IsInitialized =  RegisterClassEx(wc)
       END IF
    END IF

    IF IsInitialized THEN
       LOCAL Img AS LONG
'      // Create GDIPLUS image from file
       Img = zCreateImageFromFile(zFullpathImageName)
       IF Img THEN
          Style& = %WS_CHILD OR %WS_VISIBLE OR %WS_TABSTOP 
          hBut = CreateWindowEx(%WS_EX_TRANSPARENT, zClass, zLabel, Style&, x, y, xW, yH, hOwner, ButID, zInstance, BYVAL %NULL)
          IF hBut THEN
'            // Save Img handle as a property
             CALL zSetButProperty(hBut, %BUTTON_Style, %BS_PUSHBUTTON)
             CALL zSetButProperty(hBut, %BUTTON_TEXT_COLOR, ARGBColor)
             CALL zSetButProperty(hBut, %BUTTON_Image, Img)
             FUNCTION = hBut
          ELSE
'            // Delete image
             CALL zDisposeImage(Img)
          END IF
       END IF
    END IF
END FUNCTION

'// Create the main window system buttons
SUB zCreateSysButton (BYVAL hMain AS LONG)
    LOCAL rc AS RECT
    LOCAL hBut, imgW, imgH, MinSizeX, StartX, StartY, x, y, yLed AS LONG
    LOCAL zTip AS ASCIIZ * 20
    LOCAL zImageFile AS ASCIIZ * %MAX_PATH
    LOCAL sUsePath AS STRING
    IF IsWindow(hMain) THEN
       CALL GetClientRect(hMain, rc)

       StartX = 8: StartY = 2

       zImageFile = sUsePath + "BTN_Close.png"
       hBut = zButImage(hMain, zImageFile, -100, -100, %ID_CLOSE)
       CALL zGetImageSize(zGetButImage(hBut), imgW, imgH): imgW = imgW \ 5
       MinSizeX = MinSizeX + imgW
       x = rc.nRight - imgW - StartX: y = StartY: CALL MoveWindow(hBut, x, y, imgW, imgH, %TRUE)
       CALL zSetAnchorMode(hBut, %ANCHOR_RIGHT)
       IF IsFrench() THEN zTip = "Fermer" ELSE zTip = "Close"
       CALL zCreateToolTip(hBut, zTip)

       zImageFile = sUsePath + "BTN_Led.png": yLed = y + imgH + 4
       hBut = zButImage(hMain, zImageFile, -100, -100, %ID_LED)
       CALL zGetImageSize(zGetButImage(hBut), imgW, imgH): imgW = imgW \ 2
       CALL MoveWindow(hBut, x, yLed, imgW, imgH, %TRUE)
       CALL zSetAnchorMode(hBut, %ANCHOR_RIGHT)

       zImageFile = sUsePath + "BTN_Restore.png"
       hBut = zButImage(hMain, zImageFile, -100, -100, %ID_RESTORE)
       CALL ShowWindow(hBut, %SW_HIDE)
       CALL zGetImageSize(zGetButImage(hBut), imgW, imgH): imgW = imgW \ 5
       MinSizeX = MinSizeX + imgW
       x = x - imgW: CALL MoveWindow(hBut, x, y, imgW, imgH, %FALSE)
       CALL zSetAnchorMode(hBut, %ANCHOR_RIGHT)
       IF IsFrench() THEN zTip = "Niveau infrieur" ELSE zTip = "Restore"
       CALL zCreateToolTip(hBut, zTip)

       zImageFile = sUsePath + "BTN_Maximize.png"
       hBut = zButImage(hMain, zImageFile, -100, -100, %ID_MAXIMIZE)
       CALL zGetImageSize(zGetButImage(hBut), imgW, imgH): imgW = imgW \ 5
       CALL MoveWindow(hBut, x, y, imgW, imgH, %TRUE)
       CALL zSetAnchorMode(hBut, %ANCHOR_RIGHT)
       IF IsFrench() THEN zTip = "Agrandir" ELSE zTip = "Maximize"
       CALL zCreateToolTip(hBut, zTip)

       zImageFile = sUsePath + "BTN_Minimize.png"
       hBut = zButImage(hMain, zImageFile, -100, -100, %ID_MINIMIZE)
       CALL zGetImageSize(zGetButImage(hBut), imgW, imgH): imgW = imgW \ 5
       MinSizeX = MinSizeX + imgW
       x = x - imgW: CALL MoveWindow(hBut, x, y, imgW, imgH, %TRUE)
       CALL zSetAnchorMode(hBut, %ANCHOR_RIGHT)
       IF IsFrench() THEN zTip = "Reduire" ELSE zTip = "Iconize"
       CALL zCreateToolTip(hBut, zTip)

'      // Create GDIPLUS image from file
       CALL zSetMainProperty(hMain, %FORM_TopLeft, zCreateImageFromFile((sUsePath + "FORM_TopLeft.png")))
       CALL zSetMainProperty(hMain, %FORM_TopSide, zCreateImageFromFile((sUsePath + "FORM_TopSide.png")))
       CALL zSetMainProperty(hMain, %FORM_TopRight, zCreateImageFromFile((sUsePath + "FORM_TopRight.png")))
       CALL zSetMainProperty(hMain, %FORM_SideLeft, zCreateImageFromFile((sUsePath + "FORM_SideLeft.png")))
       CALL zSetMainProperty(hMain, %FORM_Center, zCreateImageFromFile((sUsePath + "FORM_Center.png")))
       CALL zSetMainProperty(hMain, %FORM_SideRight, zCreateImageFromFile((sUsePath + "FORM_SideRight.png")))
       CALL zSetMainProperty(hMain, %FORM_BottomLeft, zCreateImageFromFile((sUsePath + "FORM_BottomLeft.png")))
       CALL zSetMainProperty(hMain, %FORM_BottomSide, zCreateImageFromFile((sUsePath + "FORM_BottomSide.png")))
       CALL zSetMainProperty(hMain, %FORM_BottomRight, zCreateImageFromFile((sUsePath + "FORM_BottomRight.png")))
       CALL zDrawBackground()

       CALL zMinTrackSizeX(rc.nRight)  ' MinSizeX
       CALL zMinTrackSizeY(rc.nBottom) ' MAX&(imgH, 22)

    END IF
END SUB

'// Main entry point
FUNCTION WINMAIN (BYVAL hInstance     AS LONG, _
                  BYVAL hPrevInstance AS LONG, _
                  BYVAL lpCmdLine     AS ASCIIZ PTR, _
                  BYVAL iCmdShow      AS LONG) AS LONG

    LOCAL Msg         AS tagMsg
    LOCAL wc          AS WndClassEx
    LOCAL zClass      AS ASCIIZ * 80
    LOCAL dwExStyle   AS DWORD
    LOCAL dwStyle     AS DWORD
    LOCAL rc          AS RECT
    LOCAL x           AS LONG
    LOCAL y           AS LONG
    LOCAL hMutex      AS DWORD
    LOCAL hFound      AS DWORD
    LOCAL hMain       AS LONG
'
    LOCAL hWinXP_Lib           AS LONG ' Handle to WinXP Theme DLL
    LOCAL hWinXP_IsThemeActive AS LONG ' Handle to WinXP's IsThemeActive function
    LOCAL IsInitialized        AS LONG
    LOCAL hGDIplus             AS LONG ' GDIPLUS
    LOCAL hBut, imgW, imgH     AS LONG

    zClass = "ZSKINPOPUP"
'
    hMutex = CreateMutex(BYVAL %Null, 0, zClass)
    IF hMutex THEN
       IF GetLastError = %ERROR_ALREADY_EXISTS THEN
          DO
             hFound = FindWindow(zClass, ""): IF hFound THEN EXIT DO
             WHILE PeekMessage(Msg, %NULL, %NULL, %NULL, %PM_REMOVE): WEND
          LOOP
          IF IsIconic(hFound) THEN CALL ShowWindow(hFound, %SW_RESTORE)
          CALL SetForeGroundWindow(hFound)
          FUNCTION = 0
          EXIT FUNCTION
       END IF
    END IF
'
    wc.cbSize = SIZEOF(wc)
    IsInitialized = GetClassInfoEx(zInstance, zClass, wc)
    IF IsInitialized    = 0 THEN
       wc.cbSize        = SIZEOF(wc)
       wc.style         = %CS_HREDRAW OR %CS_VREDRAW OR %CS_DBLCLKS ' OR %CS_DROPSHADOW
       wc.lpfnWndProc   = CODEPTR(WndProc)
       wc.cbClsExtra    = 0
       wc.cbWndExtra    = %EXTEND_EXTRA * 4
       wc.hInstance     = zInstance
       wc.hIcon         = %NULL ' LoadIcon(wc.hInstance, "PROGRAM")
       wc.hCursor       = %NULL
       wc.hbrBackground = %NULL ' Don't paint the class window background
       wc.lpszMenuName  = %NULL
       wc.lpszClassName = VARPTR(zClass)
       wc.hIconSm       = wc.hIcon
       IF RegisterClassEx(wc) THEN IsInitialized = %TRUE
    END IF
'
    IF IsInitialized THEN
'
     ' Load the WinXP Theme support (if applicable)
       hWinXP_Lib = LoadLibrary("UxTheme.dll")
       IF hWinXP_Lib THEN
          hWinXP_IsThemeActive = GetProcAddress(hWinXP_Lib, "IsThemeActive")
       END IF
'
       CALL InitCommonControls
'
'      // Init GDIPLUS
       hGDIplus = zGdipStart()
'
     ' Window Extended Style
       dwExStyle = 0
     ' Windows Style, if you can avoid using   %WS_CLIPCHILDREN OR %WS_CLIPSIBLINGS
       dwStyle = %WS_POPUP OR %WS_VISIBLE ' OR %WS_CLIPCHILDREN OR %WS_CLIPSIBLINGS
'
       CALL SetRect(rc, 0, 0, %XMIN_SIZE, %YMIN_SIZE)
'      // Note: indeed we don't need AdjustWindowRectEx, because we use do not use a non-client area
'      // but it won't hurt anything to keep it, in case we change our mind ;)
       CALL AdjustWindowRectEx(rc, dwStyle, %FALSE, dwExStyle)  ' Adjust Window To True Requested Size
'
       x = MAX&((GetSystemMetrics(%SM_CXSCREEN) - rc.nRight - rc.nLeft) \ 2, 0)
       y = MAX&((GetSystemMetrics(%SM_CYSCREEN) - rc.nBottom - rc.nTop) \ 2, 0)
'
     ' Create The Window
       MyTitle$ = "Template"
       hMain = CreateWindowEx(dwExStyle, _           ' Extended Style For The Window
                             zClass, _               ' Class Name
                             (MyTitle$), _           ' Window Title
                             dwStyle, _              ' Defined Window Style
                             x, y, _                 ' Window Position
                             rc.nRight - rc.nLeft, _ ' Calculate Window Width
                             rc.nBottom - rc.nTop, _ ' Calculate Window Height
                             %NULL, _                ' No Parent Window
                             %NULL, _                ' No Menu
                             wc.hInstance, _         ' Instance
                             BYVAL %NULL)            ' Dont Pass Anything To WM_CREATE
'
       IF hMain THEN
'         // Save hMain handle
          CALL zMainWindow(hMain)
'         // Set caption color
          gColorCaption = %CAPTION_COLOR_ACTIVE
'         // Draw main form background
          CALL zDrawBackground()
'
        ' Apply WinXP Theme support
          LOCAL lRes AS LONG, pProc AS DWORD
          IF hWinXP_IsThemeActive THEN
             CALL DWORD hWinXP_IsThemeActive USING IsThemeActive TO lRes
             IF lRes  THEN pProc = GetProcAddress(lRes, "EnableThemeDialogTexture")
             IF pProc THEN CALL DWORD pProc USING EnableDialogTheme(hMain, &H01 OR &H02 OR &H04 OR &H06)
          END IF
'
        ' Create our system buttons
          CALL zCreateSysButton(hMain)

          hBut = zPushButton(hMain, "BTN_Push.png", "Button", (%XMIN_SIZE - 100) \ 2, (%YMIN_SIZE - 32) \ 2, 100, 32, %ID_PUSHBUTTON, zColorARGB(255, %CAPTION_COLOR_ACTIVE))
          'CALL EnableWindow(hBut, %FALSE)
          CALL zSetAnchorMode(hBut, %ANCHOR_CENTER)
          CALL zCreateToolTip(hBut, "This is a text push button")

          hBut = zPushButton(hMain, "BTN_Crystal.png", "Crystal button", (%XMIN_SIZE - 120) \ 2, 99, 120, 40, %ID_CRYSTALBUTTON, zColorARGB(255, RGB(255,255,255)))
          CALL zSetAnchorMode(hBut, %ANCHOR_CENTER)
          CALL zCreateToolTip(hBut, "This is a text push button")

          hBut = zButImage(hMain, "BTN_Script_load.png", -100, -100, %ID_SCRIPTBUTTON)
          CALL zGetImageSize(zGetButImage(hBut), imgW, imgH): imgW = imgW \ 5
          CALL MoveWindow(hBut, 100, 100, imgW, imgH, %TRUE)
          CALL zSetAnchorMode(hBut, %ANCHOR_NONE)
          CALL zCreateToolTip(hBut, "This is an image button")

          hBut = zButImage(hMain, "BTN_Play.png", -100, -100, %ID_PLAYBUTTON)
          CALL zGetImageSize(zGetButImage(hBut), imgW, imgH): imgW = imgW \ 5
          CALL MoveWindow(hBut, (%XMIN_SIZE - imgW) \ 2, (%YMIN_SIZE \ 2) + ((%YMIN_SIZE \ 2) - imgH) \ 2, imgW, imgH, %TRUE)
          CALL zSetAnchorMode(hBut, %ANCHOR_CENTER_HORZ_BOTTOM)
          CALL zCreateToolTip(hBut, "This is an image button")

          hBut = zButImage(hMain, "BTN_Left.png", -100, -100, %ID_LEFTBUTTON)
          CALL zGetImageSize(zGetButImage(hBut), imgW, imgH): imgW = imgW \ 5
          CALL MoveWindow(hBut, (%XMIN_SIZE - imgW) \ 2 - 50, (%YMIN_SIZE \ 2) + ((%YMIN_SIZE \ 2) - imgH) \ 2, imgW, imgH, %TRUE)
          CALL zSetAnchorMode(hBut, %ANCHOR_CENTER_HORZ_BOTTOM)
          CALL zCreateToolTip(hBut, "This is an image button")

          hBut = zButImage(hMain, "BTN_Right.png", -100, -100, %ID_RIGHTBUTTON)
          CALL zGetImageSize(zGetButImage(hBut), imgW, imgH): imgW = imgW \ 5
          CALL MoveWindow(hBut, (%XMIN_SIZE - imgW) \ 2 + 50, (%YMIN_SIZE \ 2) + ((%YMIN_SIZE \ 2) - imgH) \ 2, imgW, imgH, %TRUE)
          CALL zSetAnchorMode(hBut, %ANCHOR_CENTER_HORZ_BOTTOM)
          CALL zCreateToolTip(hBut, "This is an image button")

          hBut = zFrameButton(hMain, "Frame3D.png", "", (%XMIN_SIZE - 200) \ 2, 265, 200, 67, %ID_FRAMEBUTTON)
          CALL zSetAnchorMode(hBut, %ANCHOR_CENTER_HORZ_BOTTOM)


        ' Show the main window
          CALL ShowWindow(hMain, iCmdShow)

          WHILE GetMessage(Msg, %NULL, 0, 0)
                CALL TranslateMessage(Msg)
                CALL DispatchMessage(Msg)
          WEND

          FUNCTION = msg.wParam
       END IF

'      // UNLOAD the WinXP Theme DLL (if necessary)
       IF hWinXP_Lib THEN CALL FreeLibrary(hWinXP_Lib)

'      // UNLOAD GDIPLUS
       CALL zGdipEnd(hGDIplus)

    END IF
'
    IF hMutex THEN CALL CloseHandle(hMutex)
'
END FUNCTION

'// To detect if the main window is resizable or not
FUNCTION zWinResizable(BYVAL hWnd AS LONG) AS LONG
    LOCAL hCtl AS LONG
    hCtl = GetDlgItem(hWnd, %ID_MAXIMIZE)
    IF IsWindow(hCtl) THEN
       IF IsWindowVisible(hCtl) THEN FUNCTION = -1
    END IF
END FUNCTION

'// Monitor Windows DEF PROC to take over HITTEST detection
FUNCTION zDefWindowProc(BYVAL hWnd AS LONG, BYVAL Msg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) AS LONG
    LOCAL nRet, HITTEST AS LONG
    LOCAL rc AS RECT

    nRet = DefWindowProc(hWnd, Msg, wParam, lParam)

    IF Msg = %WM_NCHITTEST THEN
       LOCAL p AS POINTAPI
       LOCAL CaptionHeight AS LONG
       CALL zGetImageSize(zGetMainProperty(hWnd, %FORM_TopSide), 0, CaptionHeight)
       p.X = LOWRD(lParam): p.Y = HIWRD(lParam)
       CALL ScreenToClient(hWnd, p)
       IF IsZoomed(hWnd) = 0 THEN
          IF nRet = %HTCLIENT THEN
             HITTEST = %HTCAPTION
             IF p.Y > CaptionHeight THEN 
                HITTEST = %HTNOWHERE
                IF hWnd <> GetForegroundWindow THEN CALL SetFocus(hWnd)
             END IF
             IF zWinResizable(hWnd) THEN ' We fool Window
                CALL GetClientRect (hWnd, rc)
                LOCAL xF, yF, xSide, Border AS LONG
                xF = rc.nRight: yF = rc.nBottom
                xSide = 0
                Border = GetSystemMetrics(32) ' %SM_CXFRAME
                IF ((p.X >= xF - Border) AND ((p.Y >= yF - Border))) THEN
                   HITTEST = %HTBOTTOMRIGHT
                ELSE
                   '// Left side
                   IF (p.X <= 8) THEN
                       IF (p.X <= Border) THEN HITTEST = %HTLEFT
                       xSide = 1
                   END IF
                   '// Right side
                   IF (p.X >= xF - 8) THEN
                       IF (p.X >= xF - Border) THEN HITTEST = %HTRIGHT
                       xSide = 2
                   END IF
                   '// Top side
                   IF (p.Y <= Border) THEN
                       HITTEST = %HTTOP
                       IF (xSide = 1) THEN
                           HITTEST = %HTTOPLEFT
                       ELSEIF (xSide = 2) THEN
                           HITTEST = %HTTOPRIGHT
                       END IF
                   END IF
                   '// Bottom side
                   IF (p.Y >= yF - Border) THEN
                       IF (xSide = 1) THEN
                           HITTEST = %HTBOTTOMLEFT
                       ELSE
                           HITTEST = %HTBOTTOM
                       END IF
                   END IF
                END IF
             END IF
             nRet = HITTEST
          END IF
       ELSE
          IF p.Y < CaptionHeight THEN nRet = %HTCAPTION
       END IF
    END IF

    FUNCTION = nRet
END FUNCTION

'// Main window procedure
FUNCTION WndProc(BYVAL hWnd AS LONG, BYVAL Msg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) EXPORT AS LONG
    LOCAL ps AS PAINTSTRUCT
    LOCAL rc AS RECT
    LOCAL nRet, wP, hDC, hDCmem AS LONG

    SELECT CASE LONG Msg
    CASE %WM_GETMINMAXINFO
         LOCAL pMM AS MINMAXINFO PTR
         pMM = lParam
         @pMM.ptMinTrackSize.x = zMinTrackSizeX(0)
         @pMM.ptMinTrackSize.y = zMinTrackSizeY(0)

    CASE %WM_COMMAND
         IF zButtonSysCommand(hWnd, wParam) THEN FUNCTION = 0: EXIT FUNCTION

    CASE %WM_SIZE
         CALL EnumChildWindows(hWnd, CODEPTR(AnchorEnum), 0)
         CALL zDrawBackground()

    CASE %WM_SETTEXT
'        // Windows please do your job first.
         FUNCTION = DefWindowProc(hWnd, Msg, wParam, lParam)
'        // Update caption
         CALL zPaintBackground()
'        // Repaint only the caption.
         CALL GetClientRect(hWnd, rc)
         CALL zGetImageSize(zGetMainProperty(hWnd, %FORM_TopSide), 0, rc.nBottom)
         CALL InvalidateRect(hWnd, rc, 0)
         CALL UpdateWindow(hWnd)
         EXIT FUNCTION

    CASE %WM_NCLBUTTONDBLCLK
         IF IsIconic(hWnd) = 0 THEN
            LOCAL CaptionHeight AS LONG, p AS POINTAPI
            p.X = LOWRD(lParam): p.Y = HIWRD(lParam)
            CALL ScreenToClient(hWnd, p)
            CALL zGetImageSize(zGetMainProperty(hWnd, %FORM_TopSide), 0, CaptionHeight)
            IF p.Y < CaptionHeight THEN
               IF IsZoomed(hWnd) THEN
                  CALL zButtonSysCommand(hWnd, MAKLNG(%ID_RESTORE, 0))
               ELSE
                  CALL zButtonSysCommand(hWnd, MAKLNG(%ID_MAXIMIZE, 0))
               END IF
               FUNCTION = 0: EXIT FUNCTION
            END IF
         END IF

    CASE %WM_NCACTIVATE
         LOCAL hBut AS LONG
         hBut = GetDlgItem(hWnd, %ID_LED)
         IF IsWindow(hBut) THEN
'           // Windows please do your job first.
            FUNCTION = DefWindowProc(hWnd, Msg, wParam, lParam)
            IF zMainWindow(0) = GetForegroundWindow THEN 
               gColorCaption = %CAPTION_COLOR_ACTIVE
            ELSE
               gColorCaption = %CAPTION_COLOR_INACTIVE
            END IF
'           // Update caption
            CALL zPaintBackground()

'           // Repaint only the caption.
            CALL GetClientRect(hWnd, rc)
            CALL zGetImageSize(zGetMainProperty(hWnd, %FORM_TopSide), 0, rc.nBottom)
            CALL InvalidateRect(hWnd, rc, 0)
            CALL UpdateWindow(hWnd)

            EXIT FUNCTION
         END IF
    
    CASE %WM_ERASEBKGND
'        CALL zPaintToScreen(hWnd, wParam, 0, 0, 0)
         FUNCTION = 1: EXIT FUNCTION

    CASE %WM_PAINT
         BeginPaint(hWnd, ps)
         CALL zPaintToScreen(hWnd, ps.hDC, 0, 0, 0)
         CALL EndPaint(hWnd, ps)
         FUNCTION = 0: EXIT FUNCTION

    CASE %WM_DESTROY
'        // Delete the GDIPLUS image skin components
         LOCAL K AS LONG
         FOR K = %FORM_TopLeft TO %FORM_BottomRight
             CALL zDisposeImage(zGetMainProperty(hWnd, K))
         NEXT
'        // Clear paint resources
         LOCAL hPaintBitmap AS LONG
         hPaintBitmap = zGetPaintBitmap(hWnd)
         CALL zDeleteObject(hPaintBitmap): CALL zSetMainProperty(hWnd, %FORM_PaintBitmap, hPaintBitmap)
         hDC = zGetPaintDC(hWnd)
         IF hDC THEN CALL DeleteDC(hDC): hDC = 0: CALL zSetMainProperty(hWnd, %FORM_PaintDC, hDC)

         CALL PostQuitMessage(0)
         FUNCTION = 0: EXIT FUNCTION
    END SELECT

    FUNCTION = zDefWindowProc(hWnd, Msg, wParam, lParam)

END FUNCTION

